<?
/*
 ************************************************************************
 * File Name   : CheckUserType.php
 * Class Name  : KCCheckUserType
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("USERREGENV"))   require("../KUserRegEnv.php");
if(!defined("KCREGISTERUI")) require(USERREG_CLASS . "/KCRegisterUI.php");
if(!defined("KCUSERTYPESB")) require(J_CLASS_PATH  . "/KCUserTypeSB.php");
if(!defined("KCUSERINFO"))   require(J_CLASS_PATH  . "/KCUserInfo.php");
if(!defined("KCTextBox"))    require(K_LIB_PATH    . "/KCTextBox.php");
if(!defined("KCHAKJ"))       require(J_CLASS_PATH  . "/KCHakj.php");
if(!defined("KCYEONSU"))     require(J_CLASS_PATH  . "/KCYeonsu.php");
define("KCCHECKUSERTYPE", true);
class KCCheckUserType extends KCRegisterUI
{
    var $m_UserType;
    var $m_Jumin1;
    var $m_Jumin2;
    var $m_Name;
    var $m_KeyValue;
    var $m_ConfirmUser;
    var $m_Description;
    var $m_Refresh;
    var $m_Action;
    var $m_Command;
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCCheckUserType()
    {
        $this->KCRegisterUI();
        $this->m_ConfirmUser = false;
        $this->m_Refresh     = "false";
        $this->m_Action      = "CheckUserType.php";
        $this->m_Command     = "ConfirmUser";
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function StartRegisterTemplate()
    {
        $this->SetTemplate("CheckUserType.ihtml");
        $this->SetBlock("inputuser", "tinputuser");
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function ExtraInitializeControl()
    {
        $this->m_UserType  = new KCUserTypeSB("UserType");
        $this->m_Jumin1    = new KCTextBox("Jumin1");
        $this->m_Jumin2    = new KCTextBox("Jumin2");
        $this->m_Name      = new KCTextBox("Name");
        $this->m_KeyValue  = new KCTextBox("KeyValue");
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function InitializedDataSet()
    {
        $this->m_Description = "ֱб л, , ܷ, п, ,   Ȯ ʿմϴ. ʿ  Էֽʽÿ. <br><br>Ϲ ȸ    ʿմϴ. Ŀ  α ϸ, ο ʿ ź 纻(ֹε,  ) FAX(063-281-7049) Ǵ  ּž մϴ.  Ȯ ģ ȸ  Խ  Ⱑ ϸ, ׷   ȸ մϴ.";
        $this->m_UserType->LoadData();
        $this->SetInputDisplay();
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetInputDisplay()
    {
        $this->m_Template->set_var("tinputuser",   $this->m_Template->get_var("inputuser"));
        $this->m_Jumin1->SetAttribute("style",     "width:59px;");
        $this->m_Jumin1->SetAttribute("class",     "forms");
        $this->m_Jumin1->SetAttribute("size",      "6");
        $this->m_Jumin1->SetAttribute("maxlength", "6");
        $this->m_Jumin1->SetAttribute("onkeypress", "return KeyCheck(event)");

        $this->m_Jumin2->SetAttribute("style",     "width:59px;");
        $this->m_Jumin2->SetAttribute("class",     "forms");
        $this->m_Jumin2->SetAttribute("size",      "7");
        $this->m_Jumin2->SetAttribute("maxlength", "7");
        $this->m_Jumin2->SetAttribute("onkeypress", "return KeyCheck(event)");

        $this->m_Name->SetAttribute("style", "width:86px;");
        $this->m_Name->SetAttribute("class", "forms");
        $this->m_KeyValue->SetAttribute("style", "width:86px;");
        $this->m_KeyValue->SetAttribute("class", "forms");

        $this->m_UserType->SetAttribute("onchange", "DisableKeyValue()");
        if($this->m_ConfirmUser)
        {
            $this->m_Jumin1->SetAttribute("readonly", "readonly");
            $this->m_Jumin2->SetAttribute("readonly", "readonly");
            $this->m_Name->SetAttribute("readonly", "readonly");
            $this->m_KeyValue->SetAttribute("readonly", "readonly");
        }

        $this->m_Template->set_var(array(
            ACTION      => $this->m_Action,
            COMMAND     => $this->m_Command,
            USERTYPE    => $this->m_UserType->SBBind(),
            JUMIN1      => $this->m_Jumin1->GetInputBox(),
            JUMIN2      => $this->m_Jumin2->GetInputBox(),
            NAME        => $this->m_Name->GetInputBox(),
            KEYVALUE    => $this->m_KeyValue->GetInputBox(),
            DESCRIPTION => $this->m_Description,
            REFRESH     => $this->m_Refresh
        ));
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetRegisterUIValue()
    {

    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetConfirmedUser($IsSuccess, $Msg)
    {
        global $HTTP_POST_VARS;
        if($IsSuccess)
        {
            $this->m_ConfirmUser = true;
            $this->m_Jumin1->SetValue($HTTP_POST_VARS["Jumin1"]);
            $this->m_Jumin2->SetValue($HTTP_POST_VARS["Jumin2"]);
            $this->m_Name->SetValue($HTTP_POST_VARS["Name"]);
            $this->m_KeyValue->SetValue($HTTP_POST_VARS["KeyValue"]);
            $this->m_UserType->LoadData($HTTP_POST_VARS["UserType"]);
            $this->m_Description = $Msg;
            $this->m_Refresh     = "true";
            $this->m_Action      = "Register.php";
            $this->m_Command     = "";
        }
        else
        {
            $this->m_Description = $Msg;
            $this->m_UserType->LoadData();
        }
        $this->SetInputDisplay();
    }

    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function ConfirmUser()
    {
        global $HTTP_POST_VARS;
        $Jumin = $HTTP_POST_VARS["Jumin1"] . "-" . $HTTP_POST_VARS["Jumin2"] ;
        $UserInfo = new KCUserInfo;

        switch($HTTP_POST_VARS["UserType"])
        {
            case "1":
            case "2":
            case "3":
            case "4":
            case "5":
                $HakInfo = new KCHakj($HTTP_POST_VARS["UserType"]);
                break;
            case "6":
                $HakInfo = new KCYeonsu();
                break;
            case "7":
            default:
        }

        //Ϲݻڰ ƴѰ
        if($HTTP_POST_VARS["UserType"] != "7")
        {
            //  л缭 캸
            if($HakInfo->LoadData($HTTP_POST_VARS["KeyValue"]))
            {
                //Է KeyValue     캻.
                if($HakInfo->m_Name == $HTTP_POST_VARS["Name"]
                    && $HakInfo->m_Juminno == $HTTP_POST_VARS["Jumin1"]. "-".$HTTP_POST_VARS["Jumin2"])
                {
                    //  ̹ ϵǾ ִ  캻.
                    if($UserInfo->CheckUser($Jumin))
                    {
                        $this->SetConfirmedUser(false," '$Jumin' ̹ ϵ ֹε ȣԴϴ.");
                    }
                    else
                    {
                        $this->SetConfirmedUser(true,"밡  Դϴ.  Ͻø Ȯιư Ŭϼ");
                    }
                }
                //KeyValue   ġ ʴ 
                else
                {

                    $this->SetConfirmedUser(false,"   ġ ʽϴ. ̸ ֹεϹȣ Ȯֽʽÿ");
                }
            }
            //л KeyValue   
            else
            {
                $this->SetConfirmedUser(false," ֱб   Ÿ ϴ.");
            }
        }
        //Ϲݻڴ   Ŀ   ִ.
        else
        {
            //̹ ϵǾ ִ  캻.
            if($UserInfo->CheckUser($Jumin))
            {
                $this->SetConfirmedUser(false," '$Jumin' ̹ ϵ ֹε ȣԴϴ.");
            }
            else
            {
                $this->SetConfirmedUser(true,"밡  Դϴ. Ϲݻڴ  Ȯ  ʿմϴ.  Ͻø Ȯιư Ŭϼ");
            }
        }
    }
}

    $CheckUserType = new KCCheckUserType;
    $CheckUserType->PageLoad();
    $CheckUserType->LoadTemplate();
?>
