<?
/*
 ************************************************************************
 * File Name   : FindPasswd.php
 * Class Name  : KCFindPasswd
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    : 
 * Update Date :
 ************************************************************************
 */


if(!defined("USERREGENV"))    require("../KUserRegEnv.php");
if(!defined("KCREGISTERUI"))  require(USERREG_CLASS . "/KCRegisterUI.php");
if(!defined("KCUSERTYPESB"))  require(J_CLASS_PATH . "/KCUserTypeSB.php");
if(!defined("KCMAIL"))        require(K_LIB_PATH . "/KCMail.php");


define("KCFINDPASSWD", true);
class KCFindPasswd extends KCRegisterUI
{    
    var $m_UserType;
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCFindPasswd()
    {
        $this->KCRegisterUI();
        $this->m_UserType = new KCUserTypeSB("UserType");
    }
    
    
    /* --------------------------------------------------
     * access : protected
     * override 
     * -------------------------------------------------- */    
    function StartTemplate()
    {
        $this->InitializeTemplate("./template");
        $this->SetTemplate("FindPasswd.ihtml");    
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function InitializedDataSet()
    {
        $this->SetBlock("sucess", "tsucess");
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function SetRegisterUIValue()
    {
        $this->m_UserType->LoadData();
        $this->m_Template->set_var("USERTYPE", $this->m_UserType->SBBind());        
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function SendPasswdByMail($UserName, $EMail, $UserId, $NewPasswd)
    {   
        $Ret = false;
        $SendMail = new KCMail;
        $SendMail->SetSender("ֱб", "web@jnue.ac.kr");        
        $SendMail->SetReceiver($UserName, $EMail);
        $SendMail->SetSubject("[ֱб]  н Դϴ. ");

        $Template = new Template("template");
        $Template->set_file("MailForm", "FindPasswdMail.ihtml");
        $Template->set_var(array(
            USERNAME  => "$UserName",
            NEWPASSWD => "$NewPasswd",
            USERID    => "$UserId"
        ));
        
        $Template->parse("OUT", "MailForm");
        $Body = $Template->getp("OUT");        
        
        
        if($SendMail->SendMail($Body))
        {
            $Ret = true;
        }
        else
        {
            $this->m_ErrMsg = $SendMail->m_ErrMsg;
            echo $this->m_ErrMsg;
        }
        return $Ret;
        
    }
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function ConfirmUser()
    {        
        global $HTTP_POST_VARS;
        $Description = "";
        $UserInfo = new KCUserInfo;
        if($UserInfo->LoadData($HTTP_POST_VARS["UserId"]))
        {
            if($UserInfo->m_Name == $HTTP_POST_VARS["Name"]
                && $UserInfo->m_Jumin == $HTTP_POST_VARS["Jumin1"]."-".$HTTP_POST_VARS["Jumin2"]
                && $UserInfo->m_UserType == $HTTP_POST_VARS["UserType"])
            {
                $NewPasswd = substr(md5(time()), 0, 10);
                if($UserInfo->UpdatePasswd($HTTP_POST_VARS["UserId"], $NewPasswd))
                {
                    if($UserInfo->m_EMail != "@")
                    {
                        if($this->SendPasswdByMail($UserInfo->m_Name, $UserInfo->m_EMail, $UserInfo->m_UserId, $NewPasswd))
                        {
                            $Description = " н带 <font color=blue>$UserInfo->m_EMail </font>  ߼ ߽ϴ.Ȯ Ͻð α  ݵ н带 Ͽֽʽÿ";
                        }
                        else
                        {
                            $Description = "error : $this->m_ErrMsg <br> ߼ ߽ϴ. ";
                        }
                    }
                    else
                    {
                        $Description = "    ϴ. <br> ڿ Ͻʽÿ.  <br>  ̿뿡  ǻ ȭ E-Mail ֽñ ٶϴ.<br> (ȭ: 281-7044, :(bureumi@jnue.ac.kr)) ";
                    }
                    $this->SetBlock("confirm", "tconfirm");
                    $this->m_Template->set_var(array(
                        READONLY    => "readonly",
                        DISABLED    => "disabled=true",
                        DESCRIPTION => $Description
                        
                    ));                    
                }                
            }
            else
            {
                $this->m_JSUtil->AlertBack("  ġ ʽϴ.");                                
            }
        }
        else
        {
            $this->m_JSUtil->AlertBack("شϴ ID    ϴ.");
        }
    }
}

    $FindPasswd = new KCFindPasswd;
    $FindPasswd->PageLoad();
    $FindPasswd->LoadTemplate();
?>