<?
/*
 ************************************************************************
 * File Name   : [FILENAME].php
 * Class Name  : KC[FILENAME]
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 *              All Rights Reserved.
 *              http://www.konlo.net
 * function    :
 * Update Date :
 ************************************************************************
 */


define("KC[FILENAME]", true);
if(!defined("[ENV]"))        require("../[ENV].php");
if(!defined("[BASECLASS]"))  require(K_LIB_PATH . "/[BASECLASS].php");
if(!defined("KCSQLCLAUSE"))  require(K_LIB_PATH . "/KCSqlClause.php");
if(!defined("KCTEXTBOX"))    require(K_LIB_PATH   . "/KCTextBox.php");

class KC[FILENAME] extends [BASECLASS]
{
    var $m_SearchFlag;
    var $m_SearchWord;

    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KC[FILENAME]()
    {
        $this->[BASECLASS]();
        $this->m_ViewTitleImage = false;
    }

   
    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function StartTemplate()
    {
        $this->InitializeTemplate("./template");
        $this->SetTemplate("[FILENAME].ihtml");
        $this->SetBlock("row", "rows");
    }    


    /* ---------------------------------------------
     * virtual function.
     * Set WebParameter to memeber variable.
     * ---------------------------------------------*/
    function SetWebParameter()
    {
        global $HTTP_GET_VARS;
        $this->m_SearchWord = $HTTP_GET_VARS["sw"];
        if($this->m_SearchWord != null && $this->m_SearchWord != "")
        {
            $this->m_SearchFlag = true;            
        }
    }


    /* ---------------------------------------------
     * virtual function.
     * Extra WebParameter is used, When Set Overriden
     * SetWebParameter.
     * ---------------------------------------------*/
    /*
    function SetExtraWebParameter()
    {
        global $HTTP_GET_VARS;
        $this->m_SearchWord = $HTTP_GET_VARS["sw"];
        if($this->m_SearchWord != null && $this->m_SearchWord != "")
        {
            $this->m_SearchFlag = true;            
        }
    }
    */

    /* --------------------------------------------------
     * virtual function
     * access : protected
     * Set UI value.
     * -------------------------------------------------- */
    function SetUIValue()
    {
        ;
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetInitData()
    {
        $this->[FILENAME]List();
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function [FILENAME]List()
    {
        $DbMan     = new KCDbSql;
        $SqlClause = new KCSqlClause();
        $SqlClause->SetTable("[TABLENAME]");
        $SqlClause->SetField("[FIELDNAME]");
        
        //$SqlClause->SetGroupBy("GROUP BY [GROUPBY]");

        //˻ Query  ֱ
        if($this->m_SearchFlag)
        {
            $FieldFlag = true;
            if($FieldFlag)
                $SqlClause->SetWhere("BT.$FieldName like '%$this->m_SearchWord%' ");
        }

        //$SqlClause->SetOrder(" ORDER BY TopOrder desc, Ref desc, ReLevel ");

        $Result = $DbMan->query($SqlClause->GetListQuery(15));
        if($Result)
        {
            if($DbMan->nf() > 0)
            {
                $StartNum     = $SqlClause->GetStartListNum();
                while($DbMan->next_record())
                {
                    $this->m_Template->set_var( array(
                        NUMBER   => $StartNum
                    ));
                    $this->m_Template->parse("rows", "row", true);
                    $StartNum -- ;
                }
            }
            else
            {
                $this->m_Template->parse("rows", "empty", true);
            }
        }
        $this->m_Template->set_var(array(
            "PAGENUMBER" => $SqlClause->PrintPageNum()
        ));
    }
}
    $[FILENAME] = new KC[FILENAME];
    $[FILENAME]->PageLoad();
    $[FILENAME]->LoadTemplate();
    $[FILENAME]->PageEnd();
?>