/*
MySQL Backup
Source Host:           localhost
Source Server Version: 4.0.13-nt
Source Database:       test
Date:                  2003-08-02 23:10:03
*/

#----------------------------
# Table structure for kb_boardmanager
#----------------------------
create table kb_boardmanager (
   TableName varchar(65) not null default 'BoardHeader.ihtml',
   Description varchar(255) not null,
   UseFlag char(1) not null default 'T',
   RegDate datetime not null default '0000-00-00 00:00:00',
   TplDirectory varchar(20) ,
   TplHeader varchar(20) not null default 'BoardHeader.ihtml',
   TplFooter varchar(20) not null default 'BoardFooter.ihtml',
   TplList varchar(20) not null default 'BoardList.ihtml',
   TplView varchar(20) not null default 'BoardView.ihtml',
   TplWrite varchar(20) not null default 'BoardWrite.ihtml',
   TplSmplList varchar(20) not null default 'BoardTopList.ihtml',
   ListPerPage smallint(6) not null default '15',
   BoardTitle varchar(50) default 'KONLO BOARD',
   TitleImage varchar(40) default './images/tit_kboard.gif',
   UseTitleImage char(1) not null default 'T',
   LimitStep smallint(6) default '-1',
   MaxUpload smallint(1) not null default '0',
   AuthList varchar(10) default 'nobody',
   AuthView varchar(10) default 'nobody',
   AuthInput varchar(10) default 'nobody',
   UseReplyList char(1) not null default 'T',
   UseCategory char(1) not null default 'F',
   primary key (TableName));

#----------------------------
# Table structure for kb_pageadmin
#----------------------------
create table kb_pageadmin (
   Idx int(11) not null auto_increment,
   PageName varchar(20) not null,
   AdminUserId varchar(20) not null,
   primary key (Idx),
   index PageAdmin (PageName, AdminUserId));

#----------------------------
# Table structure for kb_userinfo
#----------------------------
create table kb_userinfo (
   ID int(11) not null auto_increment,
   UserId varchar(20) not null,
   Passwd varchar(20) not null,
   Name varchar(20) not null,
   EMail varchar(50),
   Homepage varchar(100) not null,
   RegDate datetime not null default '0000-00-00 00:00:00',
   UniqueId varchar(33) not null,
   UserLevel char(1) not null default '0',
   IsAdmin char(1) not null default 'F',
   primary key (ID),
   index UserId (UserId));

#----------------------------
# Table structure for kb_usertype
#----------------------------
create table kb_usertype (
   UserType smallint(6) not null default '0',
   UserTypeName varchar(20) not null,
   GroupType smallint(6) not null default '0',
   UserTypeSelectBox varchar(20) not null,
   primary key (UserType));