<?
/*
 ************************************************************************
 * File Name   : KCBoardTopList.php
 * Class Name  : KCBoardTopList
 * File Type   : class
 * version     : Version. 0.1.1
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 *              All Rights Reserved.
 *              http://www.konlo.net
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KBOARDENV"))    require(KBOARDENV_PATH  . "/KBoardEnv.php");
if(!defined("KCBOARDTOPUI")) require(KBOARD_CLASS . "/KCBoardTopUI.php");

define("KCBOARDTOPLIST", true);
class KCBoardTopList extends KCBoardTopUI
{
    var $m_ListPerPage;
    var $m_ListTarget;
    var $m_TemplateFile;
    var $m_SubjectLength;
    var $m_BoardPath ;               // TopList  ũ Խ ִ ġ 
    
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCBoardTopList($TemplateDirectory = false)
    {
        $this->KCBoardTopUI($TemplateDirectory);
        $this->m_ListPerPage = 10;
        $this->m_ListTarget = "";
        $this->m_TemplateFile = false;
        $this->m_SubjectLength = 50;
        $this->m_BoardPath = false ;
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function BoardTopTemplate()
    {
        if($this->m_TemplateFile == false)
        {
            $this->m_TemplateFile = $this->m_BoardManager->m_TplSmplList;
        }
        $this->SetTemplate($this->m_TemplateFile);
        $this->SetBlock("blanktr", "tblanktr");
        $this->SetBlock("row", "rows");
        $this->SetBlock("empty", "tempty");
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetInitData()
    {
        $this->BoardTopList();
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetBoardTopUIValue()
    {
        // Ư BoardPath   Default  Ѵ.
        if($this->m_BoardPath == false)
        {
            $this->m_BoardPath = BOARD_WEB_ROOT;
        }
        $this->m_Template->set_var("BOARD_LINK_PATH", $this->m_BoardPath ); 
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function BoardTopList()
    {
        $DbMan = new KCDbSql;
        $Query = "SELECT Id, Subject, Name,Category, Hit, Step, UNIX_TIMESTAMP(Wdate) as Wdate, TopOrder 
                    FROM `$this->m_BoardTable` ORDER BY TopOrder desc, Ref desc, ReLevel limit 0, $this->m_ListPerPage";
        $Result = $DbMan->query($Query);
        if($Result)
        {

            if($DbMan->nf() > 0)
            {
                $RowCount = 1 ;
                $String = new KCString;
                $DefaultParam = $this->m_PageManager->GetHiddenParam();
                while($DbMan->next_record())
                {
                    if($RowCount != $this->m_ListPerPage)
                    {
                        $this->m_Template->set_var("tblanktr", $this->m_Template->get("blanktr"));
                    }
                    else
                    {
                        $this->m_Template->set_var("tblanktr", "");
                    }

                    /*
                    if($this->m_BoardManager->m_UseCategory == "T")
                    {
                        $Category = "[".$DbMan->f("Category"). "]";
                    }
                    */


                    $ReSpace = $this->GetSubjectSpace($DbMan->f("Step"));
                    $this->m_Template->set_var( array(
                        ID         => $DbMan->f("Id"),
                        RESPACE    => $ReSpace,
                        SUBJECT    => $String->GetLimitStr($DbMan->f("Subject"), $this->m_SubjectLength),
                        NAME       => $DbMan->f("Name"),
                        WDATE      => date("m/d", $DbMan->f("Wdate")),
                        HIT        => $DbMan->f("Hit"),
                        LISTTARGET => $this->m_ListTarget
                    ));
                    $this->m_Template->parse("rows", "row", true);
                    $RowCount ++;
                }
            }
            else
            {
                $this->m_Template->parse("rows", "empty", true);
            }
        }
    }


    /* --------------------------------------------------
     * access :
     * step ̿Ͽ  Ʈ    Ʈ 
     * -------------------------------------------------- */
    function  GetSubjectSpace($Step)
    {
        for($i = 0 ; $i < $Step ;$i ++)
        {
            $Space .="&nbsp;&nbsp;";
        }
        return $Space ;
    }
}
?>