<?
/*
 ************************************************************************
 * File Name   : KCCheckBoard.php
 * Class Name  : KCCheckBoard
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 *              All Rights Reserved.
 *              http://www.konlo.net
 * function    : 
 * Update Date : 
 ************************************************************************
 */


if(!defined("KBOARDENV")) include("../KBoardEnv.php");
if(!defined("KCBOARDMANAGERUI")) require(KBOARD_CLASS . "/KCBoardManagerUI.php");
if(!defined("KCSCOPE"))          require(KBOARD_CLASS . "/KCScope.php");

define("KCCHECKBOARD", true);
class KCCheckBoard extends KCBoardManagerUI
{
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function KCCheckBoard()
    {
        $this->KCBoardManagerUI();
    }    
    
    
    /* --------------------------------------------------
     * access : protected
     * override 
     * -------------------------------------------------- */    
    function BoardManagerTemplate()
    {
        $this->SetTemplate("CheckBoard.ihtml");        
    }    
    

    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetInitData()
    {
        $this->CheckBoardData();
    }
    
    
    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetManagerUIValue()
    {        
        $this->m_Template->set_var("CATEGORY_TABLENAME", $this->m_TableName);        
    }
    
    
    /* --------------------------------------------------
     * access : protected
     * 
     * -------------------------------------------------- */    
    function CheckBoardData()
    {
        $ScopeMng = new KCScope($this->m_TableName);
        $TotalRecord = $ScopeMng->GetTotalTableRecordCount();
        $ScopeEnd    = $ScopeMng->GetMaxScopeEnd();
        if($ScopeMng->IsValidScopeEx($TotalRecord, $ScopeEnd))
        {
            $Status = "";
        }
        else
        {
            $Status = "";            
        }
        $this->m_Template->set_var(array(
            "TABLE_NAME" => $this->m_TableName,
            "TOTAL_RECORD" => $TotalRecord,
            "SCOPEEND"    => $ScopeEnd,
            "STATUS"      => $Status
            ));        
    }
    
    
    /* --------------------------------------------------
     * access : protected
     * event function
     * -------------------------------------------------- */        
    function CorrectBoard()
    {
        $ScopeMng = new KCScope($this->m_TableName);
        $ScopeMng->CorrectBoard();
        $this->GoCurrentPage();
    }
}
?>