<?
/*
 ************************************************************************
 * File Name  : KBoardEnv.php
 * Class Name :
 * version    :
 * Copyright 2001, 2002 Na Jong Sung <konlo@konlo.net>
 * All Rights Reserved.
 * http://www.konlo.net
 * Update Date : 2003. 7. 24
 * Update Date : 2003. 10. 02
                 Comment κ ڵ  
 ************************************************************************
 */

define("KCBOARD", true);

if(!defined("KCDATABASE"))     require(K_LIB_PATH   . "/KCDataBase.php");
if(!defined("KCUPLOAD"))       require(KBOARD_CLASS . "/KCUpload.php");
if(!defined("KCBOARDCOMMENT")) require(KBOARD_CLASS . "/KCBoardComment.php");
if(!defined("KCSCOPE"))        require(KBOARD_CLASS . "/KCScope.php");

/* --------------------------------------------------
 * Board Table ϴ Class
 * -------------------------------------------------- */
class KCBoard extends KCDataBase
{
    var $m_TableName ;
    var $m_Id;
    var $m_Category;
    var $m_Name;
    var $m_EMail;
    var $m_Homepage;
    var $m_Subject;
    var $m_Contents;
    var $m_Passwd;
    var $m_Wdate;
    var $m_Ip;
    var $m_Hit;
    var $m_Ref;
    var $m_Step;
    var $m_ReLevel;
    var $m_Pds;
    var $m_TopOrder;
    var $m_ViewHtml;
    var $m_Vdate;         // view date
    var $m_NewId;
    var $m_ReplyFlag;
    var $m_Scope;  
    var $m_OrgScope;
    var $m_ParentId;
    var $m_Deleted;

    var $m_ParentScope;  // Reply ÿ ǰ  Parent Scope 
    var $m_ScopeMng  ;
    var $SCOPE_VALUE_TOPORDER = 0 ; // TopOrder    Scope 
    var $TOPSCOPEORDER_SECOND = 0; // Top scope order second
    

    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCBoard($TableName, $ReplyFlag= false, $ParentId = 0)
    {
        $this->KCDataBase();
        $this->m_TableName = $TableName;
        $this->m_ReplyFlag = $ReplyFlag;
        $this->m_NewId     = false;
        $this->m_ParentId  = $ParentId;
        $this->m_ScopeMng  = new KCScope($TableName);       
    }


    /* --------------------------------------------------
     * access : public
     * override
     * -------------------------------------------------- */
    function GetSelectSQL($Id)
    {        
        return "SELECT *, UNIX_TIMESTAMP(Wdate) as Vdate FROM `$this->m_TableName` WHERE ID = '$Id' ";
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * Move data From Database Row to member variable
     * -------------------------------------------------- */
    function LoadMemberValue($DbMan)
    {
        $this->m_Id       = $DbMan->f("Id");
        $this->m_Category = $DbMan->f("Category");
        $this->m_Name     = $DbMan->f("Name");
        $this->m_EMail    = $DbMan->f("EMail");
        $this->m_Homepage = $DbMan->f("Homepage");
        $this->m_Subject  = $DbMan->f("Subject");
        $this->m_Contents = $DbMan->f("Contents");
        $this->m_Wdate    = $DbMan->f("Wdate");
        $this->m_Vdate    = date("m/d H:i",$DbMan->f("Vdate"));
        $this->m_Ip       = $DbMan->f("Ip");
        $this->m_Hit      = $DbMan->f("Hit");
        $this->m_Ref      = $DbMan->f("Ref");
        $this->m_Step     = $DbMan->f("Step");
        $this->m_ReLevel  = $DbMan->f("ReLevel");
        $this->m_TopOrder = $DbMan->f("TopOrder");
        $this->m_ViewHtml = $DbMan->f("ViewHtml");
        $this->m_Pds      = $DbMan->f("Pds");
        $this->m_Scope    = $DbMan->f("Scope");
        $this->m_OrgScope = $DbMan->f("OrgScope"); 
        $this->m_ParentId = $DbMan->f("ParentId");
        $this->m_Deleted  = $DbMan->f("Deleted");
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetNewRef()
    {
        $Ret = "-1";
        $Query = "SELECT MAX(ref) as NewRef FROM $this->m_TableName";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $Ret = $this->m_DbMan->f("NewRef") + 1;
            }
        }
        else
        {
            $this->m_ErrMsg  = $this->m_DbMan->m_ErrMsg;
            $this->m_ErrCode = $this->m_DbMan->m_ErrCode;
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function GetReplyDocNum()
    {

        $Query = "SELECT Ref, Step, ReLevel, Scope FROM $this->m_TableName WHERE id = '$this->m_ParentId' ";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $Ref     = $this->m_DbMan->f("Ref");
                $Step    = $this->m_DbMan->f("Step") + 1;
                $ReLevel = $this->m_DbMan->f("ReLevel") ;
                $Scope   = $this->m_DbMan->f("Scope") ;
            }
        }
        else
        {
            $this->m_ErrMsg  = $this->m_DbMan->m_ErrMsg;
            $this->m_ErrCode = $this->m_DbMan->m_ErrCode;
        }
        return array($Ref, $Step, $ReLevel, $Scope);
    }


    /* --------------------------------------------------
     * access : private
     *  ȣ õ Ÿ մϴ.
     *   Ref 
     * 亯    Խù  ɴϴ.
     * -------------------------------------------------- */
    function SetDocumentNum()
    {
        if($this->m_ReplyFlag)
        {
            list($this->m_Ref, $this->m_Step, $this->m_ReLevel, $this->m_ParentScope) = $this->GetReplyDocNum();
        }
        else
        {
            $this->m_Ref     = $this->GetNewRef();
            $this->m_Step    = 0 ;
            $this->m_ReLevel = 0;
        }        
    }
    
    
    /* --------------------------------------------------
     * access : private 
     *  Scope մϴ. 
     * INSERT SetScopeData
     * -------------------------------------------------- */    
    function SetScopeData($IsUpdate)
    {
        $OPERATION_INSERT = 0;
        $OPERATION_REPLY  = 1;
        $OPERATION_UPDATE = 2;
                
        if($IsUpdate == true)
        {
            $Operation = $OPERATION_UPDATE;  
            $Scope     = $this->m_Scope;
        }
        else if($this->m_ReplyFlag == true)
        {
            $Operation = $OPERATION_REPLY;    
            $Scope     = $this->m_ParentScope;
        }
        else 
        {
            $Operation = $OPERATION_INSERT;  
            $Scope     = null;
        }
        if($this->m_ScopeMng->LoadScopeData($Operation, $Scope, $this->m_TopOrder))
        {
            $this->m_OrgScope = $this->m_ScopeMng->m_OrgScope;
            
            
            // OrgScope   ְ 
            // TopOrder   SCOPE_VALUE_TOPORDER  ִ´. 
            if($this->m_TopOrder > 0 )
            {           
                $this->m_Scope = SCOPE_VALUE_TOPORDER;     
            }                 
            else
            {
                $this->m_Scope = $this->m_OrgScope;                     
            }    
        }
        else
        {
            $this->m_ErrMsg = $this->m_ScopeMng->m_ErrMsg;
        }
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetFlagCheckBox($Value)
    {
        $Ret = $Value;
        if($Value != "T")
        {
            $Ret = "F";
        }
        return $Ret ;
    }


    /* --------------------------------------------------
     * access : public
     * override
     * $IP Update ÿ  
     * -------------------------------------------------- */
    function SetDataValue($DataValue, $IP = false, $IsUpdate = false, $Id = null)
    {
        $this->m_Category = $DataValue["Category"];
        $this->m_Name     = $DataValue["Name"];
        $this->m_EMail    = $DataValue["EMailID"]. "@" . $DataValue["EMailServer"] ;
        $this->m_Homepage = $DataValue["Homepage"];
        $this->m_Subject  = $DataValue["Subject"];
        $this->m_Contents = $DataValue["Contents"];
        $this->m_Passwd   = $DataValue["Passwd"];
        $this->m_Ip       = $IP;
        $this->m_TopOrder = $DataValue["TopOrder"];
        $this->m_ViewHtml = $this->GetFlagCheckBox($DataValue["ViewHtml"]);
        //Set Document Data. Ref, Step, ReLevel;
        if($IsUpdate == false)
        {
            $this->SetDocumentNum();
            $this->SetScopeData($IsUpdate);
        }        
        else
        {
            $Temp = $this;
            $Temp->LoadData($Id);
            if($this->m_TopOrder != $Temp->m_TopOrder)
            {                
                if($this->m_TopOrder > 0)
                {
                    $this->m_Scope = $this->SCOPE_VALUE_TOPORDER;
                }            
                else
                {
                    $this->m_Scope = $Temp->m_OrgScope;
                }
                $this->SetScopeData($IsUpdate);                                
            }
        }
    }
    
    
    /* --------------------------------------------------
     * access : public
     * ֻ Ÿ ε ϱ 
     * -------------------------------------------------- */    
    function LoadDataTop()
    {
        $Ret = false;
        $Query = "SELECT *, UNIX_TIMESTAMP(Wdate) as Vdate FROM `$this->m_TableName` ORDER BY ID DESC LIMIT 0, 1";                
        //flexible GetSelectSQL. use call_user_method        
        $Result = $this->m_DbMan->Query($Query);
        if($Result)
        {
            if($this->m_DbMan->next_record())
            {
                $this->LoadMemberValue($this->m_DbMan);
                $Ret = true;
            }
        }
        return $Ret;        
    }


    /* --------------------------------------------------
     * access : private
     * 亯  شϴ  Update ŵϴ.
     * -------------------------------------------------- */
    function UpdateReLevel()
    {
        $Ret = false;
        $Query = "UPDATE `$this->m_TableName` SET ReLevel = ReLevel + 1
                        WHERE Ref='$this->m_Ref'
                        AND ReLevel >= '$this->m_ReLevel' ";
        if($this->ExecuteQuery($Query))
        {
            $Ret = true;
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function GetInsertSQL()
    {
        return "INSERT INTO `$this->m_TableName`
                    (Category, Name,     EMail,
                     Homepage, Subject,  Contents,
                     Passwd,   Wdate,    Ip,
                     Ref,      Step,     ReLevel,
                     TopOrder, ViewHtml, Scope,
                     OrgScope, ParentId )
                    VALUES('$this->m_Category',          '$this->m_Name',     '$this->m_EMail',
                           '$this->m_Homepage',          '$this->m_Subject',  '$this->m_Contents',
                            PASSWORD('$this->m_Passwd'), now(),               '$this->m_Ip',
                           '$this->m_Ref',               '$this->m_Step',     '$this->m_ReLevel',
                           '$this->m_TopOrder',          '$this->m_ViewHtml', '$this->m_Scope',
                           '$this->m_OrgScope',          '$this->m_ParentId') ";

    }


    /* --------------------------------------------------
     * access : public
     * override
     * -------------------------------------------------- */
    function InsertData()
    {
        $Ret = false;
        $Query = $this->GetInsertSQL();
        if($this->m_ReplyFlag)
        {
            $this->UpdateReLevel();
        }
        
        //  ԷµǾ  Scope  Update ش.
        if($this->m_TopOrder > 0)
        {
            $this->IncreaseTopOrder($this->m_TopOrder);
        }        
        if($this->AffectOperate($Query))
        {            
            $Ret = $this->m_ScopeMng->UpdateScope($this->m_Scope);
        }
        else
        {
            $Ret = false;
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function GetNewId()
    {
        if($this->m_NewId == false)
        {
            $Query = "SELECT MAX(Id) as NewId FROM `$this->m_TableName` ";
            if($this->m_DbMan->query($Query))
            {
                if($this->m_DbMan->next_record())
                {
                    $this->m_NewId = $this->m_DbMan->f("NewId");
                }
            }
            return $this->m_NewId;
        }
        else
        {
            return $this->m_NewId;
        }
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function UpdateData($Id)
    {
        $Temp = $this;
        $Temp->LoadData($Id);        
        if($this->m_TopOrder > 0)
        {
            $Scope = $this->SCOPE_VALUE_TOPORDER;
            //  Ÿ TopOrder 0  0 ū ٲ Ǹ 
            // Scope SCOPE_VALUE_TOPORDER     Scope ϳ Ѵ.
            // ׸ TopOrderScope Ʈ ش.
            if($Temp->m_TopOrder == 0)
            {
                $this->m_ScopeMng->DecreaseScope($Temp->m_OrgScope);                                                                                                
                $this->m_ScopeMng->UpdateScope($this->SCOPE_VALUE_TOPORDER);
            }
        }
        else
        {
            //  Ÿ TopOrder 0  ũٰ 0 ϸ 
            // Scope ǰ Ƿ ƿ ϳ Ѵ. 
            if($Temp->m_TopOrder > 0)
            {                
                $this->m_ScopeMng->m_TopScopeOrder =  $this->TOPSCOPEORDER_SECOND;
                $this->m_ScopeMng->DecreaseScope($Temp->m_Scope);                                                                                               
                $this->m_ScopeMng->UpdateScope($Temp->m_OrgScope);                
            }                        
            $Scope = "OrgScope";
        }
        
        // Էµ  TopOrderϰ 
        if($this->m_TopOrder > 0)
        {
            // Ÿ Ϲݱ  
            if($Temp->m_TopOrder == 0)
            {
                //TopOrder Ѵ.
                $this->IncreaseTopOrder($this->m_TopOrder);                
            }
            //   TopOrder ϶
            else
            {
                //TopOrder ű.
                $this->MoveToTopOrder($Temp->m_TopOrder, $this->m_TopOrder);                
            }            
        }
        // Էµ  Ϲݱ  
        else
        {
            // $this->m_TopOrder == 0 ̹Ƿ $Temp->m_TopOrder 0 Ǵٸ 
            if( $Temp->m_TopOrder > 0 )
            {
                // ϳ ҽŲ.
                $this->DecreaseTopOrder($Temp->m_TopOrder);                
            }
        }
        
        $Query = "UPDATE `$this->m_TableName` SET
                Name     = '$this->m_Name',
                Category = '$this->m_Category',
                EMail    = '$this->m_EMail',
                Homepage = '$this->m_Homepage',
                Subject  = '$this->m_Subject',
                Contents = '$this->m_Contents',
                TopOrder = '$this->m_TopOrder',
                ViewHtml = '$this->m_ViewHtml',
                Scope    = $Scope
                WHERE Id ='$Id' ";
        return $this->ExecuteQuery($Query);
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function CheckPassword($Id, $Password)
    {
        $Ret = false;
        $Query = "SELECT ID FROM `$this->m_TableName` WHERE Id='$Id' AND Passwd = PASSWORD('$Password') ";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $Ret = true;
            }
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function IncreaseHit($Id)
    {
        $Query = "UPDATE `$this->m_TableName` SET Hit = Hit + 1 WHERE Id = '$Id'";
        return $this->AffectOperate($Query);
    }


    /* --------------------------------------------------
     * access : public
     * override
     * -------------------------------------------------- */
    function GetDeleteSQL($Idx)
    {
        return "DELETE FROM `$this->m_TableName` WHERE Id = '$Idx'" ;
    }
    
    
    /* --------------------------------------------------
     * access : private 
     *  ڽ   ִ ˻մϴ. 
     * -------------------------------------------------- */    
    function IsHaveChild($Idx)
    {
        $Ret = false;
        $Query = "SELECT COUNT(*) as ChildCount FROM `$this->m_TableName` WHERE ParentId = '$Idx'";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $ChildCount = $this->m_DbMan->f("ChildCount");                
                if($ChildCount > 0)
                    $Ret = true;
            }
        }        
        return $Ret;
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function DeleteData($Idx)
    {
        //   
        $Ret = true;
        if($this->IsHaveChild($Idx))
        {
            $Query = "UPDATE `$this->m_TableName` SET 
                        Subject ='   Ǿϴ.', 
                        Contents = '  Ǿϴ.', 
                        Pds      = 0,
                        TopOrder = 0,
                        Comment  = 0,
                        Deleted = 1 WHERE Id = '$Idx'" ;            
            $Ret = $Ret && $this->ExecuteQuery($Query);
        }
        else
        {
            
            if($this->LoadData($Idx))
            {
                // TopOrder  
                if($this->m_TopOrder > 0)
                {
                    //TopOrder ϳ ҽŲ.
                    $this->DecreaseTopOrder($this->m_TopOrder);
                }
                $ParentId = $this->m_ParentId;
                $Scope    = $this->m_Scope;
                $Query = "DELETE FROM `$this->m_TableName` WHERE Id = '$Idx'" ;                                             
                $Ret = $Ret && $this->ExecuteQuery($Query);
                
                //Scope  ϱ 
                $Ret = $Ret && $this->m_ScopeMng->DecreaseScope($Scope);
                                
                // Parent ְ 
                if($ParentId > 0)
                {   
                    if($this->LoadData($ParentId))
                    {                    
                        // شϴ     
                        if($this->m_Deleted == 1)
                        {                        
                            //Parent   Ѵ. 
                            $Ret = $Ret && $this->DeleteData($ParentId);
                        }                
                    }                
                }                
            }
        }
        
        
        //  ε  
        $Upload = new KCUpload($this->m_TableName);
        $Ret = $Ret && $Upload->DeleteData($Idx);
        
        // Comment  
        $BoardComment = new KCBoardComment($this->m_TableName);
        $Ret = $Ret && $BoardComment->DeleteCommentFormPId($Idx);
        return $Ret;        
    }


    /* --------------------------------------------------
     * access : public
     * ε  մϴ. 
     * -------------------------------------------------- */    
    function UpdatePds($Id)
    {
        $Ret = false;
        $Query = "SELECT COUNT(ID) Pds FROM `" . $this->m_TableName. "_upload` WHERE BoardId = '$Id' ";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $Pds = $this->m_DbMan->f("Pds");                
                $Query = "UPDATE `$this->m_TableName` SET Pds = '$Pds' WHERE Id = '$Id'";
                $Ret = $this->ExecuteQuery($Query);
            }
        }
        return $Ret ;
    }
    
    
    /* --------------------------------------------------
     * access : public
     * comment  Ʈ մϴ. 
     * -------------------------------------------------- */
    function UpdateComment($Id)
    {
        $Ret = false;
        $Query = "SELECT COUNT(Idx) as CommentCount FROM `" . $this->m_TableName. "_comment` WHERE PIdx = '$Id' ";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $CommentCount = $this->m_DbMan->f("CommentCount");                
                $Query = "UPDATE `$this->m_TableName` SET Comment = '$CommentCount' WHERE Id = '$Id'";
                $Ret = $this->ExecuteQuery($Query);
            }
        }
        return $Ret ;        
    }
    
    
    /* --------------------------------------------------
     * access : private
     * TopOrder Order  Ѵ.
     * -------------------------------------------------- */    
    function IncreaseTopOrder($TopOrder)
    {
        // TopOrder  TopOrder 1 ũų  ͸ Ʈ մϴ. 
        $Query = "UPDATE `$this->m_TableName` SET TopOrder = TopOrder + 1 WHERE TopOrder >= 1 AND TopOrder >= '$TopOrder'";
        return $this->ExecuteQuery($Query);        
    }
    
    
    /* --------------------------------------------------
     * access : private
     * TopOrder Order  Ѵ.
     * -------------------------------------------------- */        
    function DecreaseTopOrder($TopOrder)
    {
        // TopOrder Ҵ TopOrder 1 ũų  ͸ Ʈ մϴ. 
        $Query = "UPDATE `$this->m_TableName` SET TopOrder = TopOrder - 1 WHERE TopOrder >= 1 AND TopOrder > '$TopOrder'";
        return $this->ExecuteQuery($Query);                        
    }
    
    
    /* --------------------------------------------------
     * access : private
     * TopOrder Order  Ѵ.
     * -------------------------------------------------- */            
    function MoveToTopOrder($Source, $Destination)
    {
        if($Source > $Destination)
        {      
            $Query = "UPDATE `$this->m_TableName` SET TopOrder = TopOrder + 1 WHERE TopOrder >= '$Destination' AND TopOrder < '$Source' ";
            return $this->ExecuteQuery($Query);                        
        }
        else if($Source < $Destination)
        {   
            $Query = "UPDATE `$this->m_TableName` SET TopOrder = TopOrder - 1 WHERE TopOrder > '$Source' AND TopOrder <= '$Destination'";
            return $this->ExecuteQuery($Query);                        
        }        
    }
    

    /* --------------------------------------------------
     * access : public
     * Contents  Html  ̴ ƴϸ Text
     * Ұ  Ѵ.
     * -------------------------------------------------- */
    function GetContents()
    {
        if($this->m_ViewHtml == "F")
        {
            $Contents = str_replace("<", "&lt;", $this->m_Contents);
            $Contents = str_replace(">", "&gt;", $Contents);
            $Contents = nl2br($Contents);
            return $Contents;
        }
        else
        {
            return $this->m_Contents;
        }
    }


    /* --------------------------------------------------
     * access :
     *   ȯؼ Ѱش.
     * -------------------------------------------------- */
    function GetEMailID()
    {
        $Ret = "";
        $Mails = split("@",$this->m_EMail);
        if(count($Mails) == 2)
        {
            $Ret = $Mails[0];
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetEMailServer()
    {
        $Ret = "";
        $Mails = split("@",$this->m_EMail);
        if(count($Mails) == 2)
        {
            $Ret = $Mails[1];
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetEMail()
    {
        if($this->m_EMail == "@")
        {
            return "";
        }
        else
        {
            return $this->m_EMail;
        }
    }
}

?>
