<?
/*
 ************************************************************************
 * File Name   : KCBoardPaging.php
 * Class Name  : KCBoardPaging
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 *              All Rights Reserved.
 *              http://www.konlo.net
 * function    :
 * Update Date : 2003. 7. 22
 ************************************************************************
 */


if(!defined("KCPAGING")) require(K_LIB_PATH . "/KCPaging.php");

define("KCBOARDPAGING", true);
class KCBoardPaging extends KCPaging
{
    var $m_BoarTable;
    var $m_Scope;
    var $m_SearchPageLink;  //Search Page Link
    var $CONST_PRE_TEXT   = "prev";
    var $CONST_NEXT_TEXT  = "next";    
    
    
    var $m_SearchFlag;    // Sql ˻ ִ ɴ. ˻  īװ ˻ ϴ
                          // Scope Ѵ.     
                          
    var $WEBPARAM_SCOPE_NUMBER = "cn"; 
    var $CONST_SCOPENUM_TPL    = "|SCOPENUM|";
    var $m_MaxScope;       
    /* --------------------------------------------------
     * access : public
     * ctor. 
     * $Scope  ʾ  null
     * -------------------------------------------------- */
    function KCBoardPaging($BoardTable, $Scope, $TotalRowNum)
    {
        $this->KCPaging();
        $this->m_BoardTable     = $BoardTable;
        $this->m_SearchFlag     = false;
        $this->m_Scope          = $Scope;
        $this->m_SearchPageLink = null;
        $this->m_MaxScope       = null;
        $this->m_TotalRowNum    = $TotalRowNum;        
    }


    /* --------------------------------------------------
     * access : proteted
     * ش ̺  row  
     * -------------------------------------------------- */
    function SetTotalRowNum()
    {       
        if($this->m_TotalRowNum == null)
        {            
            // ˻ Flag ö  Where  ˻ϰ 
            if($this->m_SearchFlag)
            {
                $Query = "SELECT count(*) AS totalcount FROM `$this->m_BoardTable` BT USE KEY (OrgScope) $this->m_WhereClause " ;        
            }
            // ׷    Ʈ Count Ѵ.
            else
            {                
                $Query = "SELECT count(*) AS totalcount FROM `$this->m_BoardTable` BT " ;        
            }            
            $Result = $this->m_DbMan->query($Query);
            if($Result)
            {
                if($this->m_DbMan->next_record())
                {
                    $this->m_TotalRowNum = $this->m_DbMan->f("totalcount");
                }
            }
            else
            {
                $this->m_TotalRowNum = 0 ;
            }                        
        }
    }

    
    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function GetBeforePrintPageNum()
    {
        if($this->m_SearchFlag)
        {
            if($this->m_Scope != null && $this->m_Scope < $this->GetMaxScope())
            {
                $NextScope = $this->m_Scope + 1;
                $PageLink = str_replace("$this->CONST_SCOPENUM_TPL", $NextScope, $this->GetSearchPageLink());
                $Ret = "&nbsp;<a href='$PageLink'> ˻ </a>\n";
                return $Ret;                    
            }            
        }
        

    }
    
    
    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */    
    function GetAfterPrintPageNum()
    {   
        if($this->m_SearchFlag)
        {
            if($this->m_Scope > 1)
            {
                $NextScope = $this->m_Scope - 1;
                $PageLink = str_replace("$this->CONST_SCOPENUM_TPL", $NextScope, $this->GetSearchPageLink());
                $Ret = "&nbsp;<a href='$PageLink'> ˻ </a>\n";
                return $Ret;                    
            }            
        }
    }
    
    
    /* --------------------------------------------------
     * access : private
     * 
     * -------------------------------------------------- */    
    function GetSearchPageLink()
    {
        if($this->m_SearchPageLink == null)
        {
            // PageNumber parameter              
            $Link = $this->m_PageLink;
            $Link = str_replace("$this->CONST_PAGENUM_TPL", "", $Link);
            
            $this->m_SearchPageLink = $this->SetWebParamTPL($Link, $this->WEBPARAM_SCOPE_NUMBER, $this->m_Scope, $this->CONST_SCOPENUM_TPL);
        }
        return $this->m_SearchPageLink;
    }    
    
    
    /* --------------------------------------------------
     * access : private
     * 
     * -------------------------------------------------- */        
    function GetMaxScope()
    {
        if($this->m_MaxScope == null)
        {
            $ScopeMng = new KCScope($this->m_BoardTable);
            $ScopeMng->LoadMaxData();                
            $this->m_MaxScope = $ScopeMng->m_Scope;                    
        }
        return $this->m_MaxScope;
    }
}
?>