<?
/*
 ************************************************************************
 * File Name   : KCFileUpload.php
 * Class Name  : KCFileUpload
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 *              All Rights Reserved.
 *              http://www.konlo.net
 * function    :
 * Update Date : 2003. 07. 21
 ************************************************************************
 */


if(!defined("KCCOMMONCLASS")) require( K_LIB_PATH . "/KCCommonClass.php");
if(!defined("KCFILE"))        require(K_LIB_PATH .  "/KCFile.php");
if(!defined("KCUPLOAD"))      require(KBOARD_CLASS . "/KCUpload.php");

define("KCFILEUPLOAD", true);
class KCFileUpload extends KCCommonClass
{
    var $m_UploadDir;
    var $m_OverrideFlag ;
    var $m_UploadCount;
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCFileUpload($UploadDir = ".", $OverrideFlag = false)
    {
        $this->KCCommonClass();
        $this->m_UploadDir    = $UploadDir;
        $this->m_OverrideFlag = $OverrideFlag ;
        $this->$m_UploadCount = 0;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function CheckUploadError($Error)
    {
        $Ret = true;
        switch($Error)
        {
            case 0:
                break;
            case 1:
                $this->m_ErrMsg = "ε  ũⰡ ʹ Ůϴ. (php.ini)";
                $Ret = false;
                break;
            case 2:
                $this->m_ErrMsg = "ε  ũⰡ ʹ Ůϴ. (html form)";
                $Ret = false;
                break;
            case 3:
                break;
            case 4:
                break;
            default:
                $Ret = false;
        }
        return $Ret;

    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function CheckUploadFile()
    {
        global $HTTP_POST_FILES;
        $Ret = true;
        if(is_array($HTTP_POST_FILES))
        {
            foreach(array_keys($HTTP_POST_FILES) as $key)
            {
                $UploadFiles = $HTTP_POST_FILES[$key];

                //ε  Array <input name='XXX[]'>ΰ
                if(is_array($UploadFiles["name"]))
                {
                    for($j = 0 ; $j < count($UploadFiles["name"]) ; $j ++ )
                    {
                        $Error   = $UploadFiles["error"][$j] ;
                        $Ret     = $this->CheckUploadError($Error);
                        if($Ret == false)
                            break;
                    }
                }
                // ׷   <input name='XXX'>ΰ
                else
                {
                    $Error   = $UploadFiles["error"];
                    $Ret     = $this->CheckUploadError($Error);
                    if($Ret == false)
                        break;
                }
            }
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function SaveUploadFile($TableName, $NewId)
    {
        global $HTTP_POST_FILES;
        $Ret         = true;
        $Upload      = new KCUpload($TableName);
        if(is_array($HTTP_POST_FILES))
        {
            foreach(array_keys($HTTP_POST_FILES) as $key)
            {
                $UploadFiles = $HTTP_POST_FILES[$key];
                //ε  Array <input name='XXX[]'>ΰ
                if(is_array($UploadFiles["name"]))
                {
                    for($j = 0 ; $j < count($UploadFiles["name"]) ; $j ++ )
                    {
                        $Name    = $UploadFiles["name"][$j] ;
                        $Type    = $UploadFiles["type"][$j] ;
                        $TmpName = $UploadFiles["tmp_name"][$j] ;
                        $Size    = $UploadFiles["size"][$j] ;
                        $Error   = $UploadFiles["error"][$j] ;
                        if($Error == 0)
                        {
                            if($TmpName != "none")
                            {
                                $Ret =false;
                                $SaveName = $this->GetValidFileName($Name, $NewId);
                                if($this->WriteUploadFile($SaveName, $TmpName))
                                {
                                    $Upload->SetDataValue($NewId, $Name, $SaveName, $Type, $Size);
                                    $Upload->InsertData();
                                    $this->$m_UploadCount ++;
                                    $Ret = true;
                                }
                                else
                                {
                                    $Ret = false;
                                    $this->m_ErrMsg = "ε ";
                                    break;
                                }
                            }

                        }
                    }
                }
                // ׷   <input name='XXX'>ΰ
                else
                {
                    $Type    = $UploadFiles["type"] ;
                    $TmpName = $UploadFiles["tmp_name"] ;
                    $Size    = $UploadFiles["size"] ;
                    $Error   = $UploadFiles["error"];

                    if($Error == 0)
                    {
                        if($TmpName != "none")
                        {
                            $SaveName = $this->GetValidFileName($Name, $NewId);
                            if($this->WriteUploadFile($SaveName, $TmpName))
                            {
                                $Upload->SetDataValue($NewId, $Name, $SaveName, $Type, $Size);
                                $Upload->InsertData();
                                $this->$m_UploadCount ++ ; // ߰  ε   
                                $Ret = true;
                            }
                            else
                            {
                                $this->m_ErrMsg = "ε ";
                                $Ret = false;
                            }
                        }

                    }
                }
            }
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : private 
     * ȿ  ̸ ȯմϴ. 
     * -------------------------------------------------- */
    function GetValidFileName($FileName, $Id)
    {
        //   ̸ timestamp ٿ ߺ Ѵ. 
        $Ret = time() . $FileName ;
        $this->CheckDirectory($this->m_UploadDir);
        
        // ϴ ɴ. 
        if(file_exists($this->m_UploadDir . "/" . $Ret))
        {
            // Ѵٸ  տ $Id ٿ ߺ Ѵ. 
            $Ret = $Id . $Ret;
            while(file_exists($this->m_UploadDir . "/" . $Ret))
            {
                $Ret = $Id.$Ret;
            }
        }
        return $Ret;
    }
    

    /* --------------------------------------------------
     * access :
     * 丮 ִ ˻ϰ   Ѵ.
     * -------------------------------------------------- */
    function CheckDirectory($UploadDirectory)
    {
    	if(!file_exists($UploadDirectory) )
    	{
    		mkdir($UploadDirectory, 0777);
    		chmod($UploadDirectory, 0706);
    	}
    }


    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function WriteUploadFile($Name, $TmpName)
    {
        return $this->MoveUploadedFile($TmpName, "$this->m_UploadDir/$Name");
    }


    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function MoveUploadedFile($FileName, $Destination)
    {
        $Destination = str_replace("\'", "'", $Destination);
        return move_uploaded_file($FileName, $Destination);        
    }
    
    
    /* --------------------------------------------------
     * access : public
     * ε  丮  մϴ 
     * -------------------------------------------------- */    
    function RemoveUploadDir($file)
    {
        if(file_exists($file))
        {
            chmod($file,0777); 
            if(is_dir($file)) 
            { 
                $handle = opendir($file); 
                while($filename = readdir($handle)) 
                { 
                    if ($filename != "." && $filename != "..") 
                    { 
                        $this->RemoveUploadDir($file."/".$filename); 
                    } 
                } 
                closedir($handle); 
                rmdir($file); 
            } 
            else 
            { 
                unlink($file); 
            }              
        }
    }
}
?>