<?
/*
 ************************************************************************
 * File Name   : KCTopOrderSB.php
 * Class Name  : KCTopOrderSB
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 *              All Rights Reserved.
 *              http://www.konlo.net
 * function    :
 * Update Date : 2003. 7. 27
 ************************************************************************
 */


if(!defined("KCSELECTBOX"))  require( K_LIB_PATH . "/KCSelectBox.php");
define("KCTOPORDERSB", true);
class KCTopOrderSB extends KCSelectBox
{
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCTopOrderSB($Name)
    {
        $this->KCSelectBox($Name);
    }


    /* --------------------------------------------------
     * access : public
     * override
     * -------------------------------------------------- */
    function LoadData($TableName, $IsBoardUpdate)
    {
        $MaxTopOrder = 0;
        $Query= "SELECT max(TopOrder) as MaxTopOrder FROM `$TableName`";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $MaxTopOrder = $this->m_DbMan->f("MaxTopOrder");
            }
        }


        
        
        // Ʈ  ְ  ϵ 
        if($IsBoardUpdate)
        {
            // m_DefaultValue  TopOrder 
            if($this->m_DefaultValue == 0)
            {
                $EndTopOrder = $MaxTopOrder + 1;                                        
            }
            else
            {
                $EndTopOrder = $MaxTopOrder;                
            }
        }
        else
        {
            $EndTopOrder = $MaxTopOrder + 1;                        
        }
        
        
        $Items = array();
        for( $i = 0 ; $i <= $EndTopOrder; $i ++)
        {
            $Items[$i] = $i;
        }
        $this->SetDataBaseItemsArray($Items);
    }
}
?>