<?
/*
 ************************************************************************
 * File Name   : KCUpload.php
 * Class Name  : KCUpload
 * File Type   : class
 * version     : Version. 0.1.1
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 *              All Rights Reserved.
 *              http://www.konlo.net
 * function    : 2003. 08. 20 
 * Update Date : 2003. 09. 28
                 GetUploadDataFromTop() Լ ߰ 
 ************************************************************************
 */

if(!defined("KCDATABASE"))  require(K_LIB_PATH . "/KCDataBase.php");
define("KCUPLOAD", true);
class KCUpload extends KCDataBase
{
    var $m_Id;
    var $m_BoardId;
    var $m_FileName;
    var $m_SaveFileName;
    var $m_ContentType;
    var $m_FileSize;
    var $m_DownLoad;


    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCUpload($TableName)
    {
        $this->KCDataBase();
        $this->m_TableName = $TableName;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetSelectSQL($Id)
    {
        return "SELECT * FROM  `" .$this->m_TableName. "_upload` WHERE Id = '$Id'";
    }
    
    
    /* --------------------------------------------------
     * access :
     * 
     * -------------------------------------------------- */    
    function GetTopByPIdSQL($Pid)
    {
        return "SELECT * FROM  `" .$this->m_TableName. "_upload` WHERE BoardId = '$Pid' ORDER BY Id DESC LIMIT 0, 1";        
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * Move data From Database Row to member variable
     * -------------------------------------------------- */
    function LoadMemberValue($DbMan)
    {
        $this->m_Id           = $DbMan->f("Id");
        $this->m_BoardId      = $DbMan->f("BoardId");
        $this->m_FileName     = $DbMan->f("FileName");
        $this->m_SaveFileName = $DbMan->f("SaveFileName");
        $this->m_ContentType  = $DbMan->f("ContentType");
        $this->m_FileSize     = $DbMan->f("FileSize");
        $this->m_DownLoad     = $DbMan->f("DownLoad");
    }

    
    /* --------------------------------------------------
     * access :
     * override ;
     * -------------------------------------------------- */    
    function LoadDataTopByPId($PId)
    {
        $TempSQL = $this->fpSelectSQL ;
        $this->fpSelectSQL = "GetTopByPIdSQL";
        $Ret = $this->LoadData($PId);        
        $this->fpSelectSQL = $TempSQL;
        return $Ret;                
    }
    
    
    /* --------------------------------------------------
     * access : public 
     * $Count : TOPκ  UplodatFile  
     * -------------------------------------------------- */        
    function GetUploadDataFromTop($Count)
    {
        $Ret = "";
        $Query = "SELECT * FROM  `" .$this->m_TableName. "_upload` ORDER BY Id DESC LIMIT 0, $Count";        
        //   
        if($this->m_DbMan->query($Query))
        {
            $i = 0 ;
            while($this->m_DbMan->next_record())
            {
                $this->LoadMemberValue($this->m_DbMan);
                $Ret[$i++] = $this;
            }
        }
        return $Ret;
    }
    
    

    /* --------------------------------------------------
     * access :
     * override ;
     * -------------------------------------------------- */
    function SetDataValue($BoardId, $FileName, $SaveFileName, $ContentType, $FileSize)
    {
        $this->m_BoardId      = $BoardId;
        $this->m_FileName     = $FileName;
        $this->m_SaveFileName = $SaveFileName;
        $this->m_ContentType  = $ContentType;
        $this->m_FileSize     = $FileSize;
    }


    /* --------------------------------------------------
     * access : public
     * override
     * -------------------------------------------------- */
    function GetInsertSQL()
    {
        return "INSERT INTO `" . $this->m_TableName. "_upload` (BoardId, FileName, SaveFileName, ContentType, FileSize)
                        VALUES('$this->m_BoardId', '$this->m_FileName', '$this->m_SaveFileName', '$this->m_ContentType', '$this->m_FileSize') ";
    }


    /* --------------------------------------------------
     * access : public
     * $UploadIdx  false̸ 
     * $BoardIdx شϴ  ε Ÿ Ѵ.
     * -------------------------------------------------- */
    function DeleteData($BoardId, $UploadId = false)
    {

        // Ǿ ӵǴ  upload file  
        if($UploadId == false)
        {
            $Query = "SELECT SaveFileName FROM `" . $this->m_TableName. "_upload` WHERE BoardId ='$BoardId'";

        }
        //Upload ϳϳ  
        else
        {
            $Query = "SELECT SaveFileName FROM `" . $this->m_TableName. "_upload` WHERE Id ='$UploadId'";
        }

        //   
        if($this->m_DbMan->query($Query))
        {
            while($this->m_DbMan->next_record())
            {
                $DeleteFile = UPLOAD_PATH ."/".$this->m_TableName."/".$this->m_DbMan->f("SaveFileName");
                if(file_exists($DeleteFile))
                {
                    unlink($DeleteFile);
                }
            }
        }

        // Ǿ ӵǴ  upload file  
        if($UploadId == false)
        {
            $Query = "DELETE  FROM `" . $this->m_TableName. "_upload` WHERE BoardId ='$BoardId'";
        }
        //Upload ϳϳ  
        else
        {
            $Query = "DELETE  FROM `" . $this->m_TableName. "_upload` WHERE Id ='$UploadId'";
        }
        return $this->ExecuteQuery($Query);
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function IncreaseUpload($Id)
    {
        $Query = "UPDATE `" . $this->m_TableName. "_upload` SET DownLoad = DownLoad + 1 WHERE Id = '$Id'";
        return $this->ExecuteQuery($Query);
    }
}
?>