<?
/*
 ************************************************************************
 * File Name  : KCCheckData.php
 * Class Name : KCCheckData, KCCheckValue
 * version    : ver. 0.1
 * Copyright 2001, 2002 Na Jong Sung <konlo@geonji.co.kr>
 * All Rights Reserved.
 * http://www.geonji.co.kr/~konlo
 * Description : KCArrayList class should be included.
 ************************************************************************
 */

if(!defined("KCCOMMONCLASS")) require(K_LIB_PATH . "/KCCommonClass.php");
define("KCCHECKVALUE", true);
class KCCheckValue extends KCCommonClass
{
    var $m_Value;
    var $m_StandValue;
    var $m_ErrMsg;


    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCCheckValue($Value, $StandValue, $ErrMsg)
    {
        $this->m_Value      = $Value;
        $this->m_StandValue = $StandValue;
        $this->m_ErrMsg     = $ErrMsg;
        $this->KCCommonClass();
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function CheckValue($bEqual= true)
    {
        $bRet ;
        if($this->m_Value != $this->m_StandValue)
            $bRet = true;
        else
            $bRet = false;

        if($bEqual == false)
            $bRet = !$bRet;
        return $bRet;
    }
}



if(!defined("KCARRAYLIST")) require(K_LIB_PATH . "/KCArrayList.php");
define("KCCHECKDATA", true);
class KCCheckData extends KCCommonClass
{
    var $m_alCheckData = array();


    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
	function KCCheckData()
	{
	    $this->KCCommonClass();
        $this->m_alCheckData = new KCArrayList;
	}


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function SetCheckValue($Value, $StandValue, $ErrMsg)
    {
        $mCheckValue = new KCCheckValue($Value, $StandValue, $ErrMsg);
        $this->m_alCheckData->AddValue($mCheckValue);
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function CheckData()
    {
        $bRet = true;
        for( $i = 0 ; $i < $this->m_alCheckData->Count() ; $i ++)
        {
            $mCheckValue = $this->m_alCheckData->GetAt($i);
            if(!$mCheckValue->CheckValue())
            {
                $this->m_ErrMsg = $mCheckValue->m_ErrMsg;
                $bRet = false;
                break;
            }
        }
        return $bRet ;
    }
}
?>