<?
/*
 ************************************************************************
 * File Name   : KCCheckSpeed.php
 * Class Name  : KCCheckSpeed
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KCCOMMONCLASS")) require(K_LIB_PATH . "/KCCommonClass.php");
define("KCCHECKSPEED", true);
class KCCheckSpeed extends KCCommonClass
{
    var $m_StartTime;
    var $m_StopTime;
    
    
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCCheckSpeed()
    {
        $this->KCCommonClass();
    }
    
    
    /* --------------------------------------------------
     * access : public
     * 
     * -------------------------------------------------- */    
    function StartTime()
    {
        $this->m_StartTime = microtime();        
    }
    
    
    /* --------------------------------------------------
     * access : public
     * 
     * -------------------------------------------------- */    
    function StopTime()
    {
        $this->m_StopTime = microtime();                        
    }
    
    
    /* --------------------------------------------------
     * access : public
     * 
     * -------------------------------------------------- */        
    function GetDiffTime()
    {
        return $this->Microtime2Time($this->m_StopTime) - $this->Microtime2Time($this->m_StartTime) ;
    }
    
    
    /* --------------------------------------------------
     * access : public
     * 
     * -------------------------------------------------- */            
    function Microtime2Time ($Microtime) 
    {     
        $TimeInfo = split (" ",$Microtime); 
        if (!is_array($TimeInfo)) 
        {
            return false; 
        }
        else
        {
            return $TimeInfo[1] + $TimeInfo[0]; 
        }        
    }     
}
?>