<?
/*
 ************************************************************************
 * File Name   : KCCounterMng.php
 * Class Name  : KCCounterMng
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 *              All Rights Reserved.
 *              http://www.konlo.net
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KCCOMMONCLASS")) require(K_LIB_PATH     . "/KCCommonClass.php");
if(!defined("KCCOUNTER"))     require(KCOUNTER_CLASS . "/KCCounter.php");
define("KCCOUNTERMNG", true);
class KCCounterMng extends KCCommonClass
{
    var $m_Counter;
    var $COOKIE_NAME  = "KCCOUNT";
    var $COOKIE_VALUE = "T";
    
    var $m_StartDate;
    var $m_TodayCount;
    var $m_TodayDate;
    var $m_TotalCount;
    var $m_YesterdayCount;
    
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCCounterMng()
    {
        $this->KCCommonClass();
        $this->m_Counter = new KCCounter;
        $this->m_StartDate      = false;
        $this->m_TodayCount     = false;
        $this->m_TodayDate      = false;
        $this->m_TotalCount     = false;
        $this->m_YesterdayCount = false;        
    }
    
    
    /* --------------------------------------------------
     * access : 
     * Counter Cookie  θ ǰ Count մϴ.
     * -------------------------------------------------- */
    function Count()
    {
        if(!$this->IsSetCount())
        {
            $this->SetCountCookie();
            $this->IncreaseCount();
        }
    }
    
    
    /* --------------------------------------------------
     * access : public
     *  ¥ Count  մϴ. 
     * -------------------------------------------------- */
    function IncreaseCount()
    {
        $this->m_Counter->IncreaseCount();
    }
    
    
    /* --------------------------------------------------
     * access : public
     *  Date ȯ
     * -------------------------------------------------- */
    function GetStartDate()
    {
        if($this->m_StartDate == false)
        {
            $this->m_StartDate = $this->m_Counter->GetStartDate();
        }
        return $this->m_StartDate;
    }
    
    
    /* --------------------------------------------------
     * access : public
     *  Count  ȯ 
     * -------------------------------------------------- */
    function LoadTodayInfo()
    {
        $this->m_Counter->LoadTodayCountInfo();
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function GetTodayCount()
    {
        if($this->m_TodayCount == false)
        {
            $this->m_TodayCount = $this->m_Counter->m_Count;
        }        
        return $this->m_TodayCount;
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function GetTodayDate()
    {
        if($this->m_TodayDate == false)
        {
            $this->m_TodayDate = $this->m_Counter->m_LogDate;
        }
        return $this->m_TodayDate;
    }
    
    
    /* --------------------------------------------------
     * access : public
     *  Count  ȯ
     * -------------------------------------------------- */
    function GetTotalCount()
    {
        if($this->m_TotalCount == false)
        {
            $this->m_TotalCount = $this->m_Counter->GetTotalCount();
        }
        return $this->m_TotalCount;
    }
    
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function GetYesterDayCount()
    {
        if($this->m_YesterdayCount == false)
        {
            $this->m_YesterdayCount = $this->m_Counter->GetYesterDayCount();
        }
        return $this->m_YesterdayCount;
    }
    
    
    /* --------------------------------------------------
     * access : 
     * Counter ÿ Counter Ǿ θ Cookie 
     * -------------------------------------------------- */
    function SetCountCookie()
    {        
        setcookie($this->COOKIE_NAME, $this->COOKIE_VALUE, 0, "/");
    }
    
    
    /* --------------------------------------------------
     * access : 
     * Count Cookie Ǿ ˻ 
     * -------------------------------------------------- */
    function IsSetCount()
    {
        global $_COOKIE;
        $Ret = false;        
        if($_COOKIE[$this->COOKIE_NAME] == $this->COOKIE_VALUE)
        {
            $Ret = true;
        }
        return $Ret;        
    }
    
    
    /* --------------------------------------------------
     * access : 
     * ¥  Format մϴ. 
     * $Format DATE_FORMAT() Լ ˴ϴ.
     * -------------------------------------------------- */
    function SetDateFormat($Format)
    {
        $this->m_Counter->m_LogDateFormat = $Format;
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function GetDaysFromStart()
    {
        return $this->m_Counter->GetDaysFromStart();
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function GetAverageCount()
    {
        return $this->m_Counter->GetAverageCount();
    }
}
?>