<?
/*
 ************************************************************************
 * File Name   : KCUserInfo.php
 * Class Name  : KCUserInfo
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KCDATABASE")) require(K_LIB_PATH . "/KCDataBase.php");
define("KCUSERINFO", true);
class KCUserInfo extends KCDataBase
{
    var $m_Id;
    var $m_UserId;
    var $m_Passwd;
    var $m_Name;
    var $m_Jumin;
    var $m_Sex;
    var $m_EMail;
    var $m_Address;
    var $m_Telephone;
    var $m_Hp;
    var $m_UserType;
    var $m_RegDate;
    var $m_LoginCount;
    var $m_UseFlag;
    var $m_UniqueId;

    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCUserInfo()
    {
        $this->KCDataBase();
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetDataValue($DataValue)
    {
        $this->m_UserId     = $DataValue["UserId"];
        $this->m_Passwd     = $DataValue["Passwd"];
        $this->m_Name       = $DataValue["Name"];
        $this->m_Jumin      = $DataValue["Jumin1"]."-".$DataValue["Jumin2"];
        $this->m_Sex        = $DataValue["Sex"];
        $this->m_EMail      = $DataValue["EMail1"]. "@" . $DataValue["EMail2"];
        $this->m_Address    = $DataValue["Address"];
        $this->m_Telephone  = $DataValue["Telephone1"]."-" . $DataValue["Telephone2"] . "-" . $DataValue["Telephone3"];
        $this->m_Hp         = $DataValue["Hp1"] . "-" . $DataValue["Hp2"] . "-". $DataValue["Hp3"];
        $this->m_UserType   = $DataValue["UserType"];
        $this->m_UseFlag    = $DataValue["UseFlag"];
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function GetInsertSQL()
    {
        $this->m_UniqueId = md5(time());
        return "INSERT INTO jnue_userinfo(UserId, Passwd, Name,
                Jumin, Sex, EMail,
                Address, Telephone, HP,
                UserType, RegDate, UniqueId)
                VALUES('$this->m_UserId', PASSWORD('$this->m_Passwd'), '$this->m_Name',
                '$this->m_Jumin',    '$this->m_Sex',       '$this->m_EMail',
                '$this->m_Address',  '$this->m_Telephone', '$this->m_Hp',
                '$this->m_UserType', now(),                '$this->m_UniqueId')
                 ";
    }
}
?>