<?
/*
 ************************************************************************
 * File Name   : KCBoardView.php
 * Class Name  : KCBoardView
 * File Type   : class
 * version     : Version. 0.1.1
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 *              All Rights Reserved.
 *              http://www.konlo.net
 * function    :
 * Update Date : 2003. 7. 25
 * Update Date : 2003. 10. 02
                 Comment  κ  - 
                    Comment  Comment  ȵǴ°  
 ************************************************************************
 */


if(!defined("KBOARDENV"))       require("../KBoardEnv.php");
if(!defined("KCBOARDUI"))       require(KBOARD_CLASS . "/KCBoardUI.php");
if(!defined("KCBOARD"))         require(KBOARD_CLASS . "/KCBoard.php");
if(!defined("KCUPLOAD"))        require(KBOARD_CLASS . "/KCUpload.php");
if(!defined("KCBOARDCOMMENT"))  require(KBOARD_CLASS . "/KCBoardComment.php");
define("KCBOARDVIEW", true);
class KCBoardView extends KCBoardUI
{
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCBoardView()
    {
        $this->KCBoardUI();
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function BoardTemplate()
    {
        $this->SetTemplate($this->m_BoardManager->m_TplView);
        $this->SetBlock("row", "rows");
        $this->SetBlock("empty", "tempty");
        $this->SetBlock("datcomment", "tdatcomment");
        $this->SetBlock("uploadlist", "tuploadlist");
    }


    /* --------------------------------------------------
     * access : protected
     *
     * -------------------------------------------------- */
    function SetInitData()
    {
        $this->LoadBoardData();        
    }


    /* --------------------------------------------------
     * access : protected
     *
     * -------------------------------------------------- */
    function ExtraCheckWebParameter()
    {
        $this->CheckPagePerm($this->m_BoardManager->m_AuthView);
        if(!$this->m_IsSetKey)
        {
            $this->m_CheckData->SetCheckValue("-1", "-1", "  ϴ.");
        }
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetBoardUIValue()
    {        
        if($this->IsAdmin())
        {
            $IsAdmin = "true";
        }
        else
        {
            $IsAdmin = "false";
        }
        
        $this->m_Template->set_var(array(
                "TID" => $this->m_TableIdx,
                "ISADMIN" => $IsAdmin,
                "USERNAME"    => $this->m_Auth->GetName()
                ));
        if($this->m_BoardManager->m_MaxUpload > 0)
        {
            $this->m_Template->parse("tuploadlist", "uploadlist");
        }                
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetNextPrePage($TId)
    {
        $Ret = "";
        if($TId != "-1")
        {
            $Ret = "BoardView.php?". $this->m_PageManager->GetHiddenParam() ."&tId=$TId";
        }
        else
        {
            $Ret = "javascript: alert(' ϴ.')";
        }
        return $Ret;
    }



    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function LoadBoardData()
    {        
        global $HTTP_REFERER;
        $Board = new KCBoard($this->m_BoardTable);

        // --------------------------------------------------
        // Reloadϴ  ȸ  
        // HTTP_REFERER     
        // εǾ  ȸ  ʴ´.
        if(!strstr($HTTP_REFERER,"tId=$this->m_TableIdx"))
        {
            if(!$Board->IncreaseHit($this->m_TableIdx))
            {
                $this->m_ErrMsg = "$this->m_BoardTable, ID $this->m_TableIdx ȸ ";
                $this->PrintError($this->m_ErrMsg);
            }
        }

        if($Board->LoadData($this->m_TableIdx))
        {
            $HOMEPAGELINKTEXT = "<img src='". $this->GetSkinPath() ."/images/kb_HomepageLink.gif' border=0>";
            if($Board->m_Homepage != "")
            {
                $Homepage         = "$Board->m_Homepage";
                $HomepageTarget   = "kbhomepage";
                
            }
            else
            {
                $Homepage         = "#";        
                $HomepageTarget   = "_self";
            }
            
            $this->m_Template->set_var(array(
                ID               => $Board->m_Id,
                SUBJECT          => $this->MarkSearchWord($Board->m_Subject, $this->SEARCH_FIELD_SUBJECT),
                NAME             => $this->MarkSearchWord($Board->m_Name,    $this->SEARCH_FIELD_NAME),                
                HOMEPAGE         => $Homepage,
                HOMEPAGETARGET   => $HomepageTarget,
                HOMEPAGELINKTEXT => $HOMEPAGELINKTEXT,
                EMAIL            => $Board->GetEMail(),
                CONTENTS         => $this->MarkSearchWord($Board->GetContents(), $this->SEARCH_FIELD_CONTENTS),
                WDATE            => $Board->m_Vdate,
                IP               => $Board->m_Ip,
                HIT              => $Board->m_Hit
            ));
            
            
            //  亯  Ѿų 
            // Scope TOPORDER_SCOPE_VALUE(TopOrder  )   亯   
            $TOPORDER_SCOPE_VALUE = 0;
            if(($this->m_BoardManager->m_LimitStep != "-1" 
                    && $this->m_BoardManager->m_LimitStep <= $Board->m_Step)
                OR $Board->m_Scope == $TOPORDER_SCOPE_VALUE)
            {
                $this->SetBlock("reply", "treply");
            }
            if($this->m_BoardManager->m_MaxUpload > 0 )
            {
                $this->LoadUploadFile();
            }
            $this->LoadDatComment();
        }
        else
        {
            $this->m_ErrMsg = "$this->m_BoardTable, ID $this->m_TableIdx  б⿡ ߽ϴ.";
            $this->PrintError($this->m_ErrMsg);
        }
        
    }


    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function LoadUploadFile()
    {
        $Query = "SELECT * FROM `" . $this->m_BoardTable. "_upload` WHERE BoardId = '$this->m_TableIdx'";
        $DbMan = new KCDbSql;
        if($DbMan->query($Query))
        {
            if($DbMan->nf() > 0)
            {
                $RowNum = 1;
                while($DbMan->next_record())
                {
                    if($this->IsImage($DbMan->f("ContentType")))
                    {
                        $FileName = "<img src='BoardDownLoad.php?uid=". $DbMan->f("Id") ."&tb=$this->m_BoardTable&pn=' border=0 >";
                    }
                    else
                    {
                        $FileName = $DbMan->f("FileName");
                    }
                    
                    $this->m_Template->set_var(array(
                        ROWNUM   => $RowNum,
                        UPLOADID => $DbMan->f("Id"),
                        FILENAME => $FileName,
                        FILESIZE => $this->GetFormat($DbMan->f("FileSize")),
                        DOWNLOAD => $DbMan->f("DownLoad")
                    ));
                    $this->m_Template->parse("rows", "row", true);
                    $RowNum ++;
                }
            }
            else
            {
                $this->m_Template->parse("rows", "empty", true);
            }

        }
        else
        {
            $this->m_ErrMsg = " Upload File µ ߽ϴ.";
            $this->PrintError($this->m_ErrMsg);
        }
    }


    /* --------------------------------------------------
     * access : private 
     * ̹ ȭ ˻մϴ.
     * -------------------------------------------------- */
    function IsImage($ContentType)
    {
        $Ret = false;
        $CONTENT_TYPE_IMAGE_PJPEG = "image/pjpeg";
        $CONTENT_TYPE_IMAGE_JPEG  = "image/jpeg";
        $CONTENT_TYPE_IMAGE_GIF   = "image/gif";
        $CONTENT_TYPE_IMAGE_TIFF  = "image/tiff";        
        $CONTENT_TYPE_IMAGE_XPNG  = "image/x-png";        
        $CONTENT_TYPE_IMAGE_RGB   = "image/rgb";        
        $CONTENT_TYPE_IMAGE_BMP   = "image/bmp";        
        
        
        

        switch(strtolower($ContentType))
        {
            case $CONTENT_TYPE_IMAGE_PJPEG:
            case $CONTENT_TYPE_IMAGE_JPEG:
            case $CONTENT_TYPE_IMAGE_GIF:
            case $CONTENT_TYPE_IMAGE_TIFF:
            case $CONTENT_TYPE_IMAGE_XPNG:
            case $CONTENT_TYPE_IMAGE_RGB:
            case $CONTENT_TYPE_IMAGE_BMP:
                $Ret = true;
                break;
        }                
        return $Ret;
    }
    


    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function LoadDatComment()
    {
        $Query = "SELECT * FROM `" . $this->m_BoardTable. "_comment` WHERE PIdx = '$this->m_TableIdx'";
        $DbMan = new KCDbSql;
        if($DbMan->query($Query))
        {
            if($DbMan->nf() > 0)
            {
                while($DbMan->next_record())
                {                    
                    $this->m_Template->set_var(array(
                        CIDX       => $DbMan->f("Idx"),
                        WRITER     => $DbMan->f("Writer"),
                        DATCOMMENT => nl2br($DbMan->f("DatComment")),
                        REGDATE    => $DbMan->f("RegDate")
                    ));
                    $this->m_Template->parse("tdatcomment", "datcomment", true);
                }
            }
            else
            {
                //$this->m_Template->parse("tdatcomment", "empty", true);
            }

        }
        else
        {
            $this->m_ErrMsg = "  µ ߽ϴ.";
            $this->PrintError($this->m_ErrMsg);
        }        
    }

    /* --------------------------------------------------
     * access : public
     * event function 
     * -------------------------------------------------- */
    function DeleteData()
    {
        global $HTTP_POST_VARS;
        $Board = new KCBoard($this->m_BoardTable);

        //  ׳ ٷ    
        if($this->IsAdmin())
        {
            $Board->DeleteData($this->m_TableIdx);
        }
        else
        {
            //ڰ ƴ  н带 ˻Ѵ.
            if($Board->CheckPassword($this->m_TableIdx, $HTTP_POST_VARS["Passwd"]))
            {
                $Board->DeleteData($this->m_TableIdx);                
            }
            else
            {
                $this->m_JSUtil->AlertBack("н尡 ġ ʽϴ.");
            }
        }
        $this->GoNextPage("BoardList.php");
    }
    
    
    /* --------------------------------------------------
     * access : public
     * event function 
     * -------------------------------------------------- */        
    function DeleteComment()
    {
        global $HTTP_POST_VARS;        
        $BoardComment = new KCBoardComment($this->m_BoardTable);
        if($this->IsAdmin())
        {
            if(!$BoardComment->DeleteCommentFormId($HTTP_POST_VARS["CIdx"]))
            {
                $this->m_JSUtil->AlertBack("   ߻߽ϴ.");                                           
            }            
        }
        else
        {
            if($BoardComment->CheckPasswd($HTTP_POST_VARS["CIdx"], $HTTP_POST_VARS["CommandDeletePasswd"]))
            {
                if(!$BoardComment->DeleteCommentFormId($HTTP_POST_VARS["CIdx"]))
                {
                    $this->m_JSUtil->AlertBack("   ߻߽ϴ.");                                           
                }
            }
            else
            {
                $this->m_JSUtil->AlertBack("н尡 ġ ʽϴ.");                           
            }            
        }
        $this->GoCurrentPage();        
    }
    
    
    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */    
    function AddComment()
    {
        global $HTTP_POST_VARS;
        $DataValue = $HTTP_POST_VARS;
        $DataValue["PIdx"] = $this->m_TableIdx;
        $BoardComment = new KCBoardComment($this->m_BoardTable);
        $BoardComment->SetDataValue($DataValue);        
        if(!$BoardComment->InsertData())
        {
            $this->m_JSUtil->AlertBack(" Է ");               
        }
        $this->GoCurrentPage();
        exit;
    }
}
?>
