<?
/*
 ************************************************************************
 * File Name   : KCTransfer.php
 * Class Name  : KCTransfer
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 *              All Rights Reserved.
 *              http://www.konlo.net
 * function    :
 * Update Date : 2003. 7. 22
 ************************************************************************
 */


if(!defined("KBOARDENV"))        require("../KBoardEnv.php");
if(!defined("KCBOARD"))          require(KBOARD_CLASS . "/KCBoard.php");

define("KCBOARDLIST", true);
class KCTransfer extends KCCommonClass
{
    var $m_TableName;
    var $m_SourceDB;
    var $m_DestinationDB;
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCTransfer($TableName)
    {
        $this->m_TableName = $TableName;
    }
    
    
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */    
    function SetSourceDB($Db, $User, $Passwd)
    {
        $this->m_SourceDB["DB"]     = $Db;
        $this->m_SourceDB["USER"]   = $User;
        $this->m_SourceDB["PASSWD"] = $Passwd;        
    }
    
    
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */    
    function SetDestinationDB($Db, $User, $Passwd)
    {
        $this->m_DestinationDB["DB"]     = $Db;
        $this->m_DestinationDB["USER"]   = $User;
        $this->m_DestinationDB["PASSWD"] = $Passwd;        
    }    
    
    
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */    
    function Start()
    {
        $DbMan     = new KCDbSql;        
        $DbMan->Database = $this->m_SourceDB["DB"];
        $DbMan->User     = $this->m_SourceDB["USER"];
        $DbMan->Password = $this->m_SourceDB["PASSWD"];
        
        
            
        $Query = "SELECT Id FROM `$this->m_TableName`";
        echo $Query;
        $Result = $DbMan->query($Query);        
        if($Result)
        {   
            if($DbMan->nf() > 0)
            {                
                while($DbMan->next_record())
                {
                    $Id = $DbMan->f("Id");
                    echo "$Id  Ÿ Էմϴ.<br>";
                    
                    $Board = new KCBoard($this->m_TableName);
                    $Board->m_DbMan->Database = $this->m_SourceDB["DB"];
                    $Board->m_DbMan->User     = $this->m_SourceDB["USER"];
                    $Board->m_DbMan->Password = $this->m_SourceDB["PASSWD"];
                                        
                    $Board->m_DbMan->connect();
                    if($Board->LoadData($Id))
                    {
                        $Board->m_DbMan->Link_ID  = 0;
                        $Board->m_DbMan->Database = $this->m_DestinationDB["DB"];
                        $Board->m_DbMan->User     = $this->m_DestinationDB["USER"];
                        $Board->m_DbMan->Password = $this->m_DestinationDB["PASSWD"];                                                

                        if($this->m_EMail != "")
                        {
                            $Mail = split($this->m_EMail, "@");
                        }
                        else
                        {
                            $Mail[0] = "";
                            $Mail[1] = "";                        
                        }
                        $DataValue["Category"]    = $Board->m_Category;
                        $DataValue["Name"]        = addslashes($Board->m_Name);                        
                        $DataValue["EMailID"]     = $Mail[0];
                        $DataValue["EMailServer"] = $Mail[1];
                        $DataValue["Homepage"]    = addslashes($Board->m_Homepage) ;
                        $DataValue["Subject"]     = addslashes($Board->m_Subject);
                        $DataValue["Contents"]    = addslashes($Board->m_Contents);
                        $DataValue["Passwd"]      = addslashes($Board->m_Passwd);
                        $IP                       = $Board->m_Ip;
                        $DataValue["TopOrder"]    = $Board->m_TopOrder;
                        $DataValue["ViewHtml"]    = $Board->m_ViewHtml;
                        
                        $Board->SetDataValue($DataValue, $IP);
                        $Board->InsertData();                        
                    }                    
                }
            }
        }    
    }
}

    $Transfer = new KCTransfer("kb_kstudy");
    $Transfer->SetSourceDB("konlo_net_backup", "root", "haha");
    $Transfer->SetDestinationDB("crack", "root", "haha");
    header("Content-Type : text/text");
    $Transfer->Start();
?>