<?
/*
 ************************************************************************
 * File Name  : KCManagerView.php
 * Class Name : KCManagerView
 * File Type  : class
 * version    : Version. 0.1.0
 * Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 * All Rights Reserved.
 * http://www.geonji.co.kr/~konlo
 * function   :
 ************************************************************************
 */

if(!defined("KBOARDENV")) require("../KBoardEnv.php");

if(!defined("KCBOARDMANAGERUI")) require(KBOARD_CLASS . "/KCBoardManagerUI.php");
if(!defined("KCBOARDMANAGER"))   require(KBOARD_CLASS . "/KCBoardManager.php");

define("KCMANAGERVIEW", true);
class KCManagerView extends KCBoardManagerUI
{
    var $m_BoardManager ;
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCManagerView()
    {
        $this->m_BoardManager = new KCBoardManager;
        $this->KCBoardManagerUI();
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function BoardManagerTemplate()
    {
        $this->SetTemplate("ManagerView.ihtml");
        $this->SetBlock();
        $this->m_Template->set_var(array("K_JSLIB_PATH" => K_JSLIB_PATH));
    }

    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function InitializedDataSet()
    {
        $this->LoadManagerData();
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetUIValue()
    {
        $this->m_Template->set_var("DEFAULTPARAM", $this->m_PageManager->GetHiddenParam());
    }


    /* --------------------------------------------------
     * access : private
     *
     * -------------------------------------------------- */
    function LoadManagerData()
    {
        if($this->m_BoardManager->LoadData($this->m_TableName))
        {
            $this->m_Template->set_var(array(
                TABLENAME    => $this->m_BoardManager->m_TableName,
                DESCRIPTION  => $this->m_BoardManager->m_Description,
                USEFLAG      => $this->m_BoardManager->m_UseFlag,
                WDATE        => $this->m_BoardManager->m_Wdate,
                TPLDIRECTORY => $this->m_BoardManager->m_TplDirectory,
                TPLLIST      => $this->m_BoardManager->m_TplList,
                TPLVIEW      => $this->m_BoardManager->m_TplView,
                TPLWRITE     => $this->m_BoardManager->m_TplWrite,
                TPLSMPLLIST  => $this->m_BoardManager->m_TplSmplList,
                TITLEIMAGE   => $this->m_BoardManager->m_TitleImage,
                PDSDIRECTORY => $this->m_BoardManager->m_PdsDirectory,
                LIMITSTEP    => $this->m_BoardManager->m_LimitStep,
                UPLOAD       => $this->m_BoardManager->m_Upload,
                AUTHLIST     => $this->m_BoardManager->m_AuthList,
                AUTHVIEW     => $this->m_BoardManager->m_AuthView,
                AUTHINPUT    => $this->m_BoardManager->m_AuthInput,
                USEREPLYLIST => $this->m_BoardManager->m_UseReplyList,
                USECATEGORY  => $this->m_BoardManager->m_UseCategory
            ));
        }
        else
        {
            echo "Data load ߽ϴ.";
        }
    }
}

?>