<?
/*
 ************************************************************************
 * File Name   : KCBoardSqlClause.php
 * Class Name  : KCBoardSqlClause
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@konlo.net>
 *              All Rights Reserved.
 *              http://www.konlo.net
 * function    :
 * Update Date : 2003. 7.23
 ************************************************************************
 */


if(!defined("KCSQLCLAUSE"))   require(K_LIB_PATH . "/KCSqlClause.php");
if(!defined("KCBOARDPAGING")) require(KBOARD_CLASS . "/KCBoardPaging.php"); 
if(!defined("KCSCOPE"))       require(KBOARD_CLASS . "/KCScope.php"); 
define("KCBOARDSQLCLAUSE", true);
class KCBoardSqlClause extends KCSqlClause
{
    var $m_BoardTable;
    var $m_Scope;
    var $m_SetScopeWhere;
    
    var $SCOPE_VALUE_TOPORDER = 0; //  TopOrder    Scope 
    
    
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCBoardSqlClause($BoardTable, $Scope = null, $TotalRowNum)
    {
        $this->m_BoardTable = $BoardTable;
        $this->KCSqlClause();
        $this->m_Paging = new KCBoardPaging($BoardTable, $Scope, $TotalRowNum);
        $this->m_Scope  = $Scope;
        $this->m_SetScopeWhere = false;
    }
    
    
    /* --------------------------------------------------
     * access : public
     * SearchFlag Ѵ. 
     * -------------------------------------------------- */    
    function SetSearchFlag($Flag = false)
    {
        $this->m_Paging->m_SearchFlag =  $Flag;
        if($this->m_Paging->m_SearchFlag)
        {
            $this->SetUseKey("OrgScope");
            $this->SetSearchScopeWhere();
        }
    }
        

    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function InitPaging($PageFlag = true)
    {           
        $this->m_Paging->InitPaging($this->GetTable(), $this->GetWhere(), $this->GetCountField(), $PageFlag);
        if($this->m_OffSet == null)
        {
            $this->m_OffSet = $this->m_Paging->GetOffSet();    
        }        

       
        // ˻ ƴ Ϲ Ʈ ϶ Page Scope ´. 
        // ׷   ˻ǿ Scope 
        if($this->m_Paging->m_SearchFlag == false)
        {   
            // ܺο   쿡 Page  
            if($this->m_Scope == null)
            {   
                $ScopeMng = new KCScope($this->m_BoardTable);                
                list($this->m_Scope, $this->m_OffSet) = $ScopeMng->GetScopeFromPage($this->m_OffSet);                
            }
            else
            {
                $this->m_OffSet = 0;                
            }
            $this->SetScopeWhere();
        }
        $this->m_Rows   = $this->m_Paging->GetListPerPage() ;
    }    
    
    
    /* --------------------------------------------------
     * access : protected
     * override
     * $FirstFetch  null϶ ó List Fetch
     * Ǵ ̹Ƿ TopOrder -1  ־ش. 
     * -------------------------------------------------- */    
    function SetScopeWhere()
    {
        if($this->m_SetScopeWhere == false)
        {
            $this->SetWhere("BT.Scope = '$this->m_Scope'");                        
            $this->m_SetScopeWhere = true;
        }        
    }
    
    
    /* --------------------------------------------------
     * access : protected
     * ˻   
     * -------------------------------------------------- */            
    function SetSearchScopeWhere()
    {
        if($this->m_SetScopeWhere == false)
        {
            $this->SetWhere("BT.OrgScope = '$this->m_Scope'");                        
            $this->m_SetScopeWhere = true;
        }                        
    }
    
    
    /* --------------------------------------------------
     * access : public
     * 
     * -------------------------------------------------- */        
    function GetTotalRowNum()
    {
        return $this->m_Paging->m_TotalRowNum;                
    }
    

}
?>