<?
/*
 ************************************************************************
 * File Name   : KCBoardTopUI.php
 * Class Name  : KCBoardTopUI
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KCKONLOBOARDUI")) require(KBOARD_CLASS. "/KCKonloBoardUI.php");
if(!defined("KCBOARDMANAGER")) require(KBOARD_CLASS. "/KCBoardManager.php");
if(!defined("KCPAGEMANAGER"))  require(K_LIB_PATH.   "/KCPageManager.php");
if(!defined("KCSTRING"))       require(K_LIB_PATH.   "/KCString.php");
define("KCBOARDTOPUI", true);
class KCBoardTopUI extends KCKonloBoardUI
{
    var $m_BoardTable;
    var $m_BoardManager;
    var $m_PageManager;
    var $m_TemplateDirectory;
    var $TEMPLATE_PATH;
    
    
    /* --------------------------------------------------
     * access : public
     * ctor.
     * $TemplateDirectory : 
     *     template  ִ  Direcotry  
     *     ̰   ΰ ǾѴ. 
     * -------------------------------------------------- */
    function KCBoardTopUI($TemplateDirectory = false)
    {
        $this->KCKonloBoardUI();
        $this->m_BoardManager = new KCBoardManager;
        $this->m_PageManager  = new KCPageManager;  
        $this->m_TemplateDirectory = $TemplateDirectory;                

    }


    /* --------------------------------------------------
     * access :
     * override
     * -------------------------------------------------- */
    function StartTemplate()
    {
        if($this->m_TemplateDirectory)
        {
            $InitTemplate = $this->m_TemplateDirectory;
        }            
        else
        {
            $InitTemplate = $this->TEMPLATE_PATH = KBOARD_BOARD . "/template/" . $this->m_BoardManager->m_TplDirectory ;
        }                
        $this->InitializeTemplate($InitTemplate);        
        $this->BoardTopTemplate();
    }


    /* --------------------------------------------------
     * access : protected
     * virtual function
     * -------------------------------------------------- */
    function BoardTopTemplate()
    {
        ;
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetUIValue()
    {
        $this->m_Template->set_var(array(
            "DEFAULTPARAM"   => $this->m_PageManager->GetHiddenParam(),
            "BOARD_WEB_ROOT" => BOARD_WEB_ROOT,
            "SKIN"           => BOARD_WEB_ROOT . "/template/" . $this->m_BoardManager->m_TplDirectory
        ));
        /*
        $this->m_Template->set_var("DEFAULTPARAM",   $this->m_PageManager->GetHiddenParam());
        $this->m_Template->set_var("BOARD_WEB_ROOT", BOARD_WEB_ROOT);
        TEMPLATE        
        */
        $this->SetBoardTopUIValue();
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetBoardTopUIValue()
    {
        ;
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * ---------------------------------------------*/
    function CheckWebParameter()
    {
        $this->m_CheckData->SetCheckValue($this->m_BoardTable, "", "Table  ϴ.");
        $this->CheckTableName();
        $this->ExtraCheckWebParameter();
        if(!$this->m_CheckData->CheckData())
        {
            echo $this->m_CheckData->m_ErrMsg;
            exit();
        }
        $this->m_PageManager->SetHiddenValue("tb", $this->m_BoardTable);
    }


    /* --------------------------------------------------
     * access : private
     * Check Table Name.
     * -------------------------------------------------- */
    function CheckTableName()
    {
        if(!$this->m_BoardManager->LoadData($this->m_BoardTable))
        {
            $this->m_CheckData->SetCheckValue("-1", "-1", "߸ Table ̸Դϴ.");
        }
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetBoardTable($BoardTable)
    {
        $this->m_BoardTable = $BoardTable;
    }
}
?>