<?
/*
 ************************************************************************
 * File Name  : KCKonloBoardUI.php
 * Class Name : KCKonloBoardUI
 * File Type  : class
 * version    : Version. 0.1.0
 * Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 * All Rights Reserved.
 * http://www.geonji.co.kr/~konlo
 * function   :
 ************************************************************************
 */

if(!defined("KCKLOUI"))      require(K_KLOCLASS_PATH . "/KCKLOUI.php");
if(!defined("KCCHECKSPEED")) require(K_LIB_PATH . "/KCCheckSpeed.php");


define("KCKONLOBOARDUI", true);
class KCKonloBoardUI extends KCKLOUI
{
    var $m_CheckData;
    var $TABLE_PARAM_NAME = "tb";
    var $m_IsLicenseDisplay;        // license  
    
    
    // ӵ   
    var $m_CheckSpeed ;

    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCKonloBoardUI()
    {
        $this->m_CheckSpeed = new KCCheckSpeed;
        $this->m_CheckSpeed->StartTime();
        $this->KCKLOUI();
        $this->m_IsLicenseDisplay = true;
    }
    
    
    /* --------------------------------------------------
     * access : KONLO BOARD LICENSE  
     * override 
     * -------------------------------------------------- */
    function BeforeHtml()
    {
        //echo "==" .$this->m_IsLicenseDisplay. "==";
        if($this->m_IsLicenseDisplay)
        {
            $file = KBOARD_PATH."/LICENSE";
            readfile($file);            
        }
    }
    
    
    /* --------------------------------------------------
     * access : public
     * override 
     * -------------------------------------------------- */    
    function PageEnd()
    {
        $this->m_CheckSpeed->StopTime();
        echo "\n<!-- KONLO BOARD ε ӵ \n ";
        echo $this->m_CheckSpeed->GetDiffTime();
        echo " -->\n ";
    }
}
?>