<?
/*
 ************************************************************************
 * File Name  : KCInputBox.php
 * Class Name : KCInputBox
 * File Type  : class
 * version    : Version. 0.1.0
 * Copyright 2001, 2002 Na Jong Sung <konlo@geonji.co.kr>
 * All Rights Reserved.
 * http://www.geonji.co.kr/~konlo
 ************************************************************************
 */

if(!defined("KCWEBCONTROL")) require(K_LIB_PATH . "/KCWebControl.php");
define("KCINPUTBOX", true);
class KCInputBox extends KCWebControl
{
    var $m_Value;
    var $m_Selected;
    var $m_Comment;
    var $m_Type;
    var $INPUT_TYPE_TEXT     = "text";
    var $INPUT_TYPE_CHECKBOX = "checkbox";
    var $INPUT_TYPE_RADIO    = "radio";
    var $INPUT_TYPE_BUTTON   = "button";
    var $INPUT_TYPE_PASSWORD = "password";

    /* ---------------------------------------------
     * access : public
     * ctor.
     * ---------------------------------------------*/
    function KCInputBox($Name = "", $Value = "", $Comment = "")
    {
        $this->m_Value   = $Value;
        $this->m_Comment = $Comment;
        $this->KCWebControl($Name);
    }


    /* --------------------------------------------------
     * access : public
     * -------------------------------------------------- */
    function SetNameValue($Name, $Value)
    {
        $this->SetName($Name);
        $this->SetValue($Value);
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function SetValue($Value)
    {
        $this->m_Value = $Value;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetValue()
    {
        $Value = "";
        $Value = str_replace("\"", "&quot;", $this->m_Value);
        return $Value;
    }


    /* ---------------------------------------------
     * Get Check Box
     * ---------------------------------------------*/
    function GetInputBox()
    {
        $CheckBox = "<input type=$this->m_Type name='$this->m_ControlName' value=\"". $this->GetValue() ."\" ". $this->GetAttribute() ." $this->m_Selected> $this->m_Comment";
        return $CheckBox;
    }
}
?>